/*
    WebMaker - KDE HTML Editor
    Copyright (C) 1998, 1999 Alexei Dets <dets@services.ru>
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
			
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
					
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/    

#ifndef _EDITORVIEW_H_

#define _EDITORVIEW_H_

#include <qtabbar.h>
#include <qwidgetstack.h>
#include "htmledit.moc.h"

class KTabBar:public QTabBar
{
 public:
  KTabBar(QWidget *parent=0, const char *name=0);
		virtual ~KTabBar();
		virtual QSize sizeHint() const;
  virtual int addTab(QTab *newTab);
		virtual void removeTab(int id);
		virtual void setTabLabel(int id, const char *label);
 protected:
		QList<QTab> *tabsList;
};

class EditorView:public QWidget
{
  Q_OBJECT
 public:
		EditorView(QWidget *parent=0, const char *name=0);
		virtual int addTab(QWidget *child, const char *label);
		virtual void removeTab(QWidget *child);
		virtual void showPage(QWidget *child);
		virtual void setTabLabel(QWidget *child, const char *label);
 protected:
		KTabBar *tabs;
		QWidgetStack *widgets;
 signals:
  void aboutToShow(int);
		void aboutToShow(QWidget*);
};

#endif
