/*
  $Id: mykedit.h,v 1.2 1999/01/10 07:10:11 dets Exp $

    Better Keybindings for the KEdit class in libkdeui,
    will hopefully be merged into kdelibs after the KDE 1.1 Release
  
    Copyright (C) 1999 Carsten Pfeiffer <carpdjih@sp.zrz.tu-berlin.de>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
  */


#ifndef MYKEDIT_H
#define MYKEDIT_H

#include <qevent.h>
#include <qstrlist.h>
#include <qwidget.h>

#include <keditcl.h>
#include <kapp.h> 

class MyKEdit : public KEdit
{
  Q_OBJECT
  
public:

  MyKEdit( KApplication *a=NULL,QWidget *parent=NULL, const char *name=NULL,
           const char *filename=NULL);
  virtual ~MyKEdit();
  
  void		setLeftWords(QStrList& w )  	{ myLeftWords  = w; }
  void		setRightWords(QStrList& w ) 	{ myRightWords = w; }

  QStrList	leftWords()  			{ return myLeftWords;  }
  QStrList 	rightWords() 			{ return myRightWords; }

  
protected:

  QStrList 	myLeftWords;
  QStrList 	myRightWords;
  
  virtual void	jumpOneWordLeft();
  virtual void	jumpOneWordRight();
  
  virtual void  keyPressEvent( QKeyEvent * );
  
};


#endif
