/* windows.c by Adam Rogoyski (apoc@laker.net) Temperanc on EFNet irc
 * Copyright (C) 1998, 1999 Adam Rogoyski
 * --- GNU General Public License Disclamer ---
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */


#include "hexedit.h"



void
popupGotoOffset (long filesize)
#define OFFSET_BOX_STRING_BOX 12
#define OFFSET_BOX_HEIGHT     8
#define OFFSET_BOX_WIDTH      50
#define OFFSET_STRING_BUF     11
{
   char *offstr = NULL;
   char offsetstr[OFFSET_STRING_BUF];
   long off = 0x00;
   WINDOW *wpopup = popupWindow (OFFSET_BOX_WIDTH, OFFSET_BOX_HEIGHT);

   signal (SIGINT, SIG_IGN);

   wmove (wpopup, 1, (OFFSET_BOX_WIDTH / 2) - (strlen ("Goto Offset") / 2));
   wprintw (wpopup, "Goto Offset");
   wmove (wpopup, 5, 2);
   wprintw (wpopup, "  Hint: Decimal 255 = Hex 0xFF = Octal 0377");
   wmove (wpopup, 3, (OFFSET_BOX_WIDTH / 2) - 
                     (OFFSET_BOX_STRING_BOX / 2)
                     - (strlen ("Offset:") / 2));
   wprintw (wpopup, "Offset: ");
   memset (offsetstr, 0, OFFSET_STRING_BUF);
   sprintf (offsetstr, "0x%08lX", filesize);
   werase (Globals.whelp);
   wmove (Globals.whelp, 0, 0);
   wprintw (Globals.whelp, "^G/^X/Escape Cancel");
   wrefresh (Globals.whelp);

   offstr = stringBox (wpopup, 3, (OFFSET_BOX_WIDTH / 2), 
                      OFFSET_BOX_STRING_BOX,
                      OFFSET_BOX_STRING_BOX, offsetstr);
   if (!*offstr)
      off = offset;
   else
   {
      off = strtol (offstr, NULL, 0);
      if (off < 0)
         offset = 0;
      else if (off > filesize)
         offset = filesize;
      else
         offset = off;
      cursor_x = mappos (offset & M_0x0F);
      cursor_y = MAIN_TOP_LINE;
   }
   free (offstr);
   delwin (wpopup);
   signal (SIGINT, handleInterrupt);
}


void
popupHelp (void)
#define HELP_BOX_HEIGHT     MAIN_HEIGHT
#define HELP_BOX_WIDTH      COLS
#define STRING_BUF          80
{
      /* Unless you change what you shouldn't, this is fine */
   char s[STRING_BUF];
   int y = 2;
   WINDOW *wpopup = popupWindow (HELP_BOX_WIDTH, HELP_BOX_HEIGHT);

   signal (SIGINT, SIG_IGN);
   mvwin (wpopup, MAIN_TOP_LINE, 0);
   box (wpopup, 0, 0);
   wmove (wpopup, 0, (HELP_BOX_WIDTH / 2) - (strlen ("Help") / 2));
   wprintw (wpopup, "Help");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Maneuver            Arror Keys, Home, End");
   wmove (wpopup, y++, 3);
   wprintw (wpopup,
      "Page Up             Control-y, Control-b, Alt-v, Page Up (^Y) (^B)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup,
      "Page Down           Control-v, Control-f, Page Down (^V) (^F)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Bytes <=> text      Tab, Control-i (^I)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Insert/Add Byte     Control-a, Insert (^A)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Delete Byte         Control-d, Delete (^D)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "goTo Offset         Control-t (^T)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Help                Control-g (^G)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Redraw Screen       Control-l (^L)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Save                Control-o (^O)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Save and Quit       Control-x (^X)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Quit (no save)      Control-c (^C)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "viEw as text        Control-e (^E)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Search              Control-w (^W)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "find Next           Control-n (^N)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Undo                Control-U (^U)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "ASCII <=> EBCDIC    Control-R (^R)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Switch spacings     Control-P (^P)");
   wmove (wpopup, y++, 3);
   wprintw (wpopup, "Binary Calculator   Control-/, Control-_ (^/) (^_)");

   memset (s, 0x00, STRING_BUF);
   #ifdef HAVE_SNPRINTF
      snprintf (s, STRING_BUF,
         "[N]Curses Hexedit %s Adam Rogoyski (apoc@laker.net)", VERSION);
   #else
      sprintf (s,
        "[N]Curses Hexedit %s Adam Rogoyski (apoc@laker.net)", VERSION);
   #endif
   werase (Globals.whelp);
   wmove (Globals.whelp, 0, (COLS / 2) - (strlen (s) / 2));
   wprintw (Globals.whelp, "%s", s);
   wrefresh (Globals.whelp);
            
   wrefresh (wpopup);
   getch ();
   delwin (wpopup);
   signal (SIGINT, handleInterrupt);
}


int
popupFileSave (void)
#define FILE_SAVE_STRING_BOX      50
#define FILE_SAVE_STRING_BOX_MAX  PATH_MAX
#define FILE_SAVE_HEIGHT          6
#define FILE_SAVE_WIDTH           70
{
   int result = 0;
   int saved = 0;
   char *filename = NULL;
   FILE *fp = NULL;
   WINDOW *wpopup = popupWindow (FILE_SAVE_WIDTH, FILE_SAVE_HEIGHT);
  
   signal (SIGINT, SIG_IGN);

   wmove (wpopup, 1, (FILE_SAVE_WIDTH / 2) - (strlen ("Save File") / 2));
   wprintw (wpopup, "Save File");
   wmove (wpopup, 3, 2);
   wprintw (wpopup, "Filename: ");
   werase (Globals.whelp);
   wmove (Globals.whelp, 0, 0);
   wprintw (Globals.whelp, "^G/^X/Escape Cancel");
   wrefresh (Globals.whelp);
   filename = stringBox (wpopup, 3, 2 + strlen ("Filename: "), 
                      FILE_SAVE_STRING_BOX_MAX,
                      FILE_SAVE_STRING_BOX, Globals.progname);
   chompWhiteSpace (filename);

   if (!filename);
   else if (!*filename)
      free (filename);
   else
   {
      fp = fopen (filename, "wb");
      if (!fp)
      {
         wattroff (wpopup, A_REVERSE);
         werase (wpopup);
         box (wpopup, 0, 0);
         wmove (wpopup, 1, (FILE_SAVE_WIDTH / 2)
                 - (strlen ("Cannot Save File") / 2));
         wprintw (wpopup, "Cannot Save File");
         wmove (wpopup, FILE_SAVE_HEIGHT - 3, (FILE_SAVE_WIDTH / 2) - 
                (strlen (strerror (errno)) + strlen ("Reason: ")) / 2);
         wprintw (wpopup, "Reason: %s", strerror (errno));
         wrefresh (wpopup);
         free (filename);
         getch ();
      }
      else
      {
         int buf = 0;
         int i = 0;
         int len = Globals.filesize + 1;
         while (len > 0)
         {
            if (len > 2048)
               buf = 2048;
            else
               buf = len;
            result = fwrite (filebuf + i, 1, buf, fp);
            if (result > 0)
               len -= result;
            else
               len = 0;
            i += result;
         }
         fflush (fp);
         result = fclose (fp);
         if (result == -1)
         {
            wattroff (wpopup, A_REVERSE);
            werase (wpopup);
            box (wpopup, 0, 0);
            wmove (wpopup, 1, (FILE_SAVE_WIDTH / 2)
                    - (strlen ("Cannot Save File") / 2));
            wprintw (wpopup, "Cannot Save File");
            wmove (wpopup, FILE_SAVE_HEIGHT - 3, (FILE_SAVE_WIDTH / 2) - 
                   (strlen (strerror (errno)) + strlen ("Reason: ")) / 2);
            wprintw (wpopup, "Reason: %s", strerror (errno));
            wrefresh (wpopup);
            free (filename);
            getch ();
         }
         else
         {
            saved = 1;
            Globals.modified = 0;
            free (Globals.progname);
            Globals.progname = filename;
         }
      }
   }
   signal (SIGINT, handleInterrupt);
   delwin (wpopup);
   return saved;
}


void
search (int findnext)
#define SEARCH_BOX_WIDTH  60
#define SEARCH_BOX_HEIGHT 10
#define SEARCH_STRING_BOX      50
#define SEARCH_STRING_BOX_MAX  50
{
   char *options[] = { "Find Next",
                      "search for text string",
                      "search for Hex bytes" };
   static unsigned char *laststr = NULL;
   static int first = 1;
   static int last_str_len = 0;
   static unsigned char *s = NULL;
   int done = 0;
   int selection = 0;
   wchar_t in = 0;
   WINDOW *wpopup = popupWindow (SEARCH_BOX_WIDTH, SEARCH_BOX_HEIGHT);

   if (findnext && !laststr)
      return;
   signal (SIGINT, SIG_IGN);


   werase (Globals.whelp);
   wmove (Globals.whelp, 0, 0);
   wprintw (Globals.whelp,
       "^G/^X/Escape Cancel   F/N Find Next   A Text Search   H Hex Search");
   wrefresh (Globals.whelp);

   wmove (wpopup, 1, (SEARCH_BOX_WIDTH / 2) - (strlen ("Search") / 2));
   wprintw (wpopup, "Search");
   if (first)
      selection = 1;
   if (!first)
      wattrset (wpopup, A_REVERSE);
   wmove (wpopup, 3, (SEARCH_BOX_WIDTH / 2) - (strlen (options[0]) / 2));
   wprintw (wpopup, "%s", options[0]);      
   if (!first)
      wattroff (wpopup, A_REVERSE);
   if (first)
      wattrset (wpopup, A_REVERSE);
   wmove (wpopup, 5, (SEARCH_BOX_WIDTH / 2) - (strlen (options[1]) / 2));
   wprintw (wpopup, "%s", options[1]);
   if (first)
      wattroff (wpopup, A_REVERSE);
   wmove (wpopup, 7, (SEARCH_BOX_WIDTH / 2) - (strlen (options[2]) / 2));
   wprintw (wpopup, "%s", options[2]);
   if (findnext)
   {
      selection = 0;
      done = 1;
   }
   else
      wrefresh (wpopup);
   while (!done && ((in = getch()) != '\n'))
   {
      switch (in)
      {
         case 'f':
         case 'F':
         case 'n':
         case 'N':
            first = 0;
            done = 1;
            selection = 0;
            break;
         case 'a':
         case 'A':
            first = 0;
            done = 1;
            selection = 1;
            break;
         case 'h':
         case 'H':
            first = 0;
            done = 1;
            selection = 2;
            break;
         case CONTROL_C:
         case CONTROL_G:
         case CONTROL_X:
         case ESCAPE_CHARACTER:
            done = -1;
            break;
         case KEY_UP:
         case KEY_DOWN:
            if ((in == KEY_UP) && (selection == 0))
               selection = 2;
            else if (in == KEY_UP)
               selection--;
            if ((in == KEY_DOWN) && (selection == 2))
               selection = 0;
            else if (in == KEY_DOWN)
               selection++;
            if (first && (selection == 0) && (in == KEY_UP))
               selection = 2;
            else if (first && (selection == 0) && (in == KEY_DOWN))
               selection = 1;
            if (selection == 0)
               wattrset (wpopup, A_REVERSE);
            wmove (wpopup, 3, (SEARCH_BOX_WIDTH / 2) - (strlen (options[0]) / 2));
            wprintw (wpopup, "%s", options[0]);      
            if (selection == 0)
               wattroff (wpopup, A_REVERSE);
            if (selection == 1)
                wattrset (wpopup, A_REVERSE);
            wmove (wpopup, 5, (SEARCH_BOX_WIDTH / 2) - (strlen (options[1]) / 2));
            wprintw (wpopup, "%s", options[1]);
            if (selection == 1)
                wattroff (wpopup, A_REVERSE);
            if (selection == 2)
               wattrset (wpopup, A_REVERSE);
            wmove (wpopup, 7, (SEARCH_BOX_WIDTH / 2) - (strlen (options[2]) / 2));
            wprintw (wpopup, "%s", options[2]);
            if (selection == 2)
               wattroff (wpopup, A_REVERSE);
            wrefresh (wpopup);
            break;
      }
   }
   if (done == -1)
   {
      signal (SIGINT, handleInterrupt);
      return;
   }
   done = 0;
   wmove (wpopup, 3, (SEARCH_BOX_WIDTH / 2) - (strlen (options[0]) / 2));
   wprintw (wpopup, "%*c", strlen (options[0]), ' ');
   wmove (wpopup, 5, (SEARCH_BOX_WIDTH / 2) - (strlen (options[1]) / 2));
   wprintw (wpopup, "%*c", strlen (options[1]), ' ');
   wmove (wpopup, 7, (SEARCH_BOX_WIDTH / 2) - (strlen (options[2]) / 2));
   wprintw (wpopup, "%*c", strlen (options[2]), ' ');
   if (selection == 0)
   {
      struct foundit *spot = NULL;
      if (offset < Globals.filesize - 1)
         spot = boyer_moore_search (laststr, filebuf + offset + 1,
                              last_str_len,
                              Globals.filesize - offset);
      if (spot && spot->flag)
      {
         offset += spot->offset + 1; /* started search one character
                                       ahead of offset */
         cursor_y = 1;
         cursor_x = mappos (offset & M_0x0F);
      }
      else
      {
         int i = 0;
         wattroff (wpopup, A_REVERSE);
         wmove (wpopup, (SEARCH_BOX_HEIGHT / 2) + 1, 1);
         for (i = 2; i < SEARCH_BOX_WIDTH; i++)
            wprintw (wpopup, " ");
         wmove (wpopup, (SEARCH_BOX_HEIGHT / 2) + 1, (SEARCH_BOX_WIDTH / 2)
                - (strlen ("** String not found **") / 2));
         wprintw (wpopup, "** String not found **");
         wrefresh (wpopup);
         getch ();
      }
   }
   else if (selection == 1)
   {
      unsigned char *str = NULL;
      unsigned char *strb = NULL;
      if (laststr)
      {
         free (laststr);
         laststr = NULL;
      }
      wmove (wpopup, 1, (SEARCH_BOX_WIDTH / 2) - (strlen ("Text String")
                        / 2));
      wprintw (wpopup, "Text String");
      str = strb = (unsigned char *)
                      stringBox (wpopup, (SEARCH_BOX_HEIGHT / 2) + 1,
                      (SEARCH_BOX_WIDTH - SEARCH_STRING_BOX) / 2,
                         SEARCH_STRING_BOX_MAX,
                         SEARCH_STRING_BOX, NULL);
      s = (unsigned char *) str;
      laststr = s;
      for (str = s + SEARCH_STRING_BOX_MAX - 1; str != (s - 1); str--)
      {
         if (*str != ' ')
         {
            *(str + 1) = '\0';
            done = 1;
            break;
         }
      }
      if (Globals.charset == EBCDIC_CHAR_SET)
      {
         unsigned char *p = s;
         while (*p)
         {
            *p = findEBCDIC (*p);
            p++;
         }
      }
      if (done)
      {
         struct foundit *spot = NULL;
         if (offset < Globals.filesize - 1)
            spot = boyer_moore_search (s, filebuf + offset + 1,
                                 last_str_len = strlen ((char *) s),
                                 Globals.filesize - offset);
         if (spot && spot->flag)
         {
            offset += spot->offset + 1; /* started search one character
                                          ahead of offset */
            cursor_y = 1;
            cursor_x = mappos (offset & M_0x0F);
        }
        else
        {
           int i = 0;
           wattroff (wpopup, A_REVERSE);
           wmove (wpopup, (SEARCH_BOX_HEIGHT / 2) + 1, 1);
           for (i = 2; i < SEARCH_BOX_WIDTH; i++)
              wprintw (wpopup, " ");
           wmove (wpopup, (SEARCH_BOX_HEIGHT / 2) + 1, (SEARCH_BOX_WIDTH / 2)
                  - (strlen ("** String not found **") / 2));
           wprintw (wpopup, "** String not found **");
           wrefresh (wpopup);
           getch ();
        }
      }
   }
   else if (selection == 2)
   {
#define BYTE_SEARCH_LENGTH  16
      struct ret_string *retr;
      wmove (wpopup, 1, (SEARCH_BOX_WIDTH / 2) - (strlen ("Byte Search")
                        / 2));
      wprintw (wpopup, "Byte Search");
      retr = hex_string_box (wpopup, BYTE_SEARCH_LENGTH, SEARCH_BOX_WIDTH);
      if (retr)
      {
         struct foundit *spot = NULL;
         if (offset < Globals.filesize - 1)
            spot = boyer_moore_search (retr->str, filebuf + offset + 1,
                                 last_str_len = retr->len,
                                 Globals.filesize - offset);
         if (spot && spot->flag)
         {
            offset += spot->offset + 1; /* started search one character
                                          ahead of offset */
            cursor_y = 1;
            cursor_x = mappos (offset & M_0x0F);
            if (laststr)
               free (laststr);
            laststr = malloc (retr->len + 1);
            memset (laststr, 0x00, retr->len + 1);
            memcpy (laststr, retr->str, retr->len);
            free (retr->str);
            retr->str = NULL;
            retr->len = 0;
         }
         else
         {
            int i = 0;
            wattroff (wpopup, A_REVERSE);
            wmove (wpopup, (SEARCH_BOX_HEIGHT / 2) + 1, 1);
            for (i = 2; i < SEARCH_BOX_WIDTH; i++)
               wprintw (wpopup, " ");
            wmove (wpopup, (SEARCH_BOX_HEIGHT / 2) + 1, (SEARCH_BOX_WIDTH / 2)
                   - (strlen ("** String not found **") / 2));
            wprintw (wpopup, "** String not found **");
            wrefresh (wpopup);
            getch ();
         }
      }
   }
   first = 0;
   signal (SIGINT, handleInterrupt);
   delwin (wpopup);
}
