/* $Id: PPPStats.cpp,v 1.1.1.1 1998/05/06 19:13:31 matt Exp $
   $Log: PPPStats.cpp,v $
   Revision 1.1.1.1  1998/05/06 19:13:31  matt
   Imported sources

   Revision 1.1  1998/03/22 07:08:30  matt
   *** empty log message ***


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   */


#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <net/if.h>
#include <asm/types.h>
#include <linux/ppp_defs.h>

#include <kapp.h>

#include "PPPStats.h"

typedef struct
{
    struct ppp_stats  stats;
} DclPPPInfo;


PPPStats::PPPStats()
        : _rxTotal( 0 ),
          _isUp( FALSE )
{
    if ((_s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
        perror("couldn't create IP socket");
        exit(1);
    }

    timerEvent( 0 );

    KConfig* config = KApplication::getKApplication()->getConfig();

    statsSpeed = config->readNumEntry("StatsSpeed", 5);
    pppLink = config->readNumEntry("PPPLink", 0);

    startTimer( statsSpeed * 1000 );
}


void PPPStats::timerEvent( QTimerEvent* )
{
    DclPPPInfo        PPPInfo[1];
    struct ifreq      ifreq;
    struct ppp_stats* PPPStat;
    struct ppp_stats  LastPPPStat[1];
	
    memset (& ifreq, 0, sizeof (ifreq));
    sprintf ( ifreq.ifr_ifrn.ifrn_name, "ppp%d", pppLink );
	
    ifreq.ifr_ifru.ifru_data = (caddr_t) PPPInfo;
    PPPStat = & PPPInfo->stats;
    memset (LastPPPStat, 0, sizeof (LastPPPStat));
	
    if ( (ioctl (_s, SIOCDEVPRIVATE, (caddr_t) & ifreq) < 0) || ( !PPPStat->p.ppp_ibytes ) ) {
        if ( _isUp ) {
            _isUp = FALSE;
            emit linkDown();
        }
        PPPStat->p.ppp_ibytes = 0;
        PPPStat->p.ppp_obytes = 0;
    } else if ( !_isUp ) {
        _isUp = TRUE;
        emit linkUp();
    }

    unsigned int rxDelta = PPPStat->p.ppp_ibytes - _rxTotal;
    _rxTotal = PPPStat->p.ppp_ibytes;
    if ( rxDelta == _rxTotal ) rxDelta = 0;
    emit changeStats( rxDelta );
}
