/* $Id: about.cpp,v 1.1.1.1 1998/05/06 19:13:31 matt Exp $
   $Log: about.cpp,v $

   Revision 1.3  1998/03/22 07:07:20  matt
   Icon path update

   Revision 1.2  1998/01/28 17:01:26  matt
   *** empty log message ***

   Revision 1.1  1998/01/28 14:00:12  matt
   Renamed about.cc to about.cpp

   Revision 1.1.1.1  1998/01/24 09:11:30  matt
   Imported sources


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   */

#include <qpushbt.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <kapp.h>

#include "about.h"
#include "version.h"


About::About(QWidget *parent) : QDialog(parent, "About KGet", TRUE) {
  resize(300, 250);
  setFixedSize(size());
  setCaption("About KGet");

  QString pixdir = KApplication::getKApplication()->kde_icondir();  
  QPixmap pm((pixdir + "/kget.xpm").data());
  QLabel *logo = new QLabel(this);
  logo->setPixmap(pm);
  logo->setGeometry(40, (height()-pm.height())/2 - 25, pm.width(), pm.height());

  QLabel *l;
  l = new QLabel("KGet", this);
  l->setFont(QFont("Helvetica", 19, QFont::Bold));
  l->setGeometry(130,40,100,30);

  QString s;
  s = "Version " KGETVERSION \
  "\n\nCopyright (c) 1998\nMatej Koss\n"\
  "koss@napri.sk";

  l = new QLabel(s.data(), this);
  l->setGeometry(130, 70, 230, 170);
  l->setAlignment(AlignLeft|WordBreak|ExpandTabs);

  QFrame *f1 = new QFrame(this);
  f1->setLineWidth(1);
  f1->setFrameStyle(QFrame::HLine | QFrame::Sunken);
  f1->setGeometry(10,180,280,4);


  QPushButton *b_ok = new QPushButton("Ok", this);
  b_ok->setGeometry(width()/2-40, height() - 48, 80, 32);
  b_ok->setDefault(TRUE);
  b_ok->setAutoDefault(TRUE);
  connect(b_ok, SIGNAL(released()),
	  this, SLOT(accept()));
  b_ok->setFocus();
}

