/* $Id$
   $Log$

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/


#include <klocale.h>
#include <kapp.h>
#include "dirdlg.h"


DirDlg::DirDlg(QWidget *parent, const char *name, WFlags f)
  : QWidget(parent, name, f)
{

  box = new QGroupBox(this, "box");
  box->setGeometry(10,10,365,280);
  box->setTitle(i18n("Directory Buttons"));

  lb_dir1 = new QLabel(i18n("Directory 1 :"), this);
  lb_dir1->setAlignment(AlignLeft | AlignVCenter);
  lb_dir1->setGeometry(40, 60, 260, 30);
  le_dir1 = new QLineEdit(this);
  le_dir1->setGeometry(130, 60, 200, 30);

  lb_dir2 = new QLabel(i18n("Directory 2 :"), this);
  lb_dir2->setAlignment(AlignLeft | AlignVCenter);
  lb_dir2->setGeometry(40, 110, 260, 30);
  le_dir2 = new QLineEdit(this);
  le_dir2->setGeometry(130, 110, 200, 30);

  lb_dir3 = new QLabel(i18n("Directory 3 :"), this);
  lb_dir3->setAlignment(AlignLeft | AlignVCenter);
  lb_dir3->setGeometry(40, 160, 260, 30);
  le_dir3 = new QLineEdit(this);
  le_dir3->setGeometry(130, 160, 200, 30);

  lb_dir4 = new QLabel(i18n("Directory 4 :"), this);
  lb_dir4->setAlignment(AlignLeft | AlignVCenter);
  lb_dir4->setGeometry(40, 210, 260, 30);
  le_dir4 = new QLineEdit(this);
  le_dir4->setGeometry(130, 210, 200, 30);
}


DirDlg::~DirDlg()
{
  // now delete everything we allocated before
  delete box;

  delete lb_dir1;
  delete le_dir1;

  delete lb_dir2;
  delete le_dir2;

  delete lb_dir3;
  delete le_dir3;

  delete lb_dir4;
  delete le_dir4;

  // time to say goodbye ...
}


void DirDlg::setData(QStrList *strList)
{
  QString tmp;

  tmp = strList->first();
  if ( ! tmp.isEmpty() ) {
    printf("Filename for directory button 1 found in kgetrc!\n");
    le_dir1->setText( tmp.data() );
  }
  
  tmp = strList->next();
  if ( ! tmp.isEmpty() ) {
    printf("Filename for directory button 2 found in kgetrc!\n");
    le_dir2->setText( tmp.data() );
  }

  tmp = strList->next();
  if ( ! tmp.isEmpty() ) {
    printf("Filename for directory button 3 found in kgetrc!\n");
    le_dir3->setText( tmp.data() );
  }

  tmp = strList->next();
  if ( ! tmp.isEmpty() ) {
    printf("Filename for directory button 4 found in kgetrc!\n");
    le_dir4->setText( tmp.data() );
  }
}

static QStrList strList(true);

QStrList DirDlg::data() const
{
  strList.clear();
  QString tmp;
  
  tmp = le_dir1->text();
  if( tmp.isEmpty() ) {
    printf("No filename for directory button 1 selected!\n");
    strList.append("");
  } else {
    strList.append( tmp.data() );
  }

  tmp = le_dir2->text();
  if( tmp.isEmpty() ) {
    printf("No filename for directory button 2 selected!\n");
    strList.append("");
  } else {
    strList.append( tmp.data() );
  }

  tmp = le_dir3->text();
  if( tmp.isEmpty() ) {
    printf("No filename for directory button 3 selected!\n");
    strList.append("");
  } else {
    strList.append( tmp.data() );
  }

  tmp = le_dir4->text();
  if( tmp.isEmpty() ) {
    printf("No filename for directory button 4 selected!\n");
    strList.append("");
  } else {
    strList.append( tmp.data() );
  }

  return strList;
}

