/* $Id: fontdlg.cpp,v 1.1.1.1 1998/05/06 19:13:31 matt Exp $
   $Log: fontdlg.cpp,v $
   Revision 1.1.1.1  1998/05/06 19:13:31  matt
   Imported sources

   Revision 1.3  1998/03/22 07:14:47  matt
   Added i18n

   Revision 1.2  1998/03/02 14:29:19  matt
   *** empty log message ***

   Revision 1.1  1998/02/18 16:40:10  matt
   *** empty log message ***


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   */

#include <klocale.h>
#include <kapp.h>
#include <kfontdialog.h>

#include "fontdlg.h"


FontDlg::FontDlg(QWidget *parent, const char *name, WFlags f)
  : QWidget(parent, name, f)
{

  box = new QGroupBox(this, "box");
  box->setGeometry(10,10,365,280);
  box->setTitle(i18n("Set Default Font"));

  button = new QPushButton(this);
  button->setGeometry(235,225,80,25);
  button->setText(i18n("Change"));
  connect(button,SIGNAL(clicked()),this,SLOT(setFont()));

  familylabel = new QLabel(this);
  familylabel->setGeometry(40,65,135,25);
  familylabel->setText(i18n("Family:"));

  familylabeldisp = new QLabel(this);
  familylabeldisp->setGeometry(130,65,150,25);	
  familylabeldisp->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);

  sizelabel = new QLabel(this);
  sizelabel->setGeometry(40,105,100,25);
  sizelabel->setText(i18n("Point Size:"));

  sizelabeldisp = new QLabel(this);
  sizelabeldisp->setGeometry(130,105,60,25);	
  sizelabeldisp->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);

  stylelabel = new QLabel(this);
  stylelabel->setGeometry(40,140,80,25);
  stylelabel->setText(i18n("Style:"));

  stylelabeldisp = new QLabel(this);
  stylelabeldisp->setGeometry(130,145,80,23);
  stylelabeldisp->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);

  weightlabel = new QLabel(this);
  weightlabel->setGeometry(40,180,80,25);
  weightlabel->setText(i18n("Weight:"));

  weightlabeldisp = new QLabel(this);
  weightlabeldisp->setGeometry(130,185,80,23);
  weightlabeldisp->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
}


void FontDlg::setFont(){
  KFontDialog::getFont(font);

  familylabeldisp->setText(font.family());

  if(font.bold())
    weightlabeldisp->setText(i18n("Bold"));
  else
    weightlabeldisp->setText(i18n("Normal"));

  if(font.italic())
    stylelabeldisp->setText(i18n("Italic"));
  else
    stylelabeldisp->setText(i18n("Roman"));

  QString size;
  size.setNum(font.pointSize());
  sizelabeldisp->setText(size);
}


void FontDlg::setData(QFont font) {
  familylabeldisp->setText( font.family() );

  QString size;
  size.setNum(font.pointSize());
  sizelabeldisp->setText( size.data() );

  if(font.italic())
    stylelabeldisp->setText(i18n("Italic"));
  else
    stylelabeldisp->setText(i18n("Roman"));

  if(font.bold())
    weightlabeldisp->setText(i18n("Bold"));
  else
    weightlabeldisp->setText(i18n("Normal"));
}


static QStrList strList(true);

QFont FontDlg::data() const
{
  return font;
}
