#ifndef _KGETOPTDLG_H
#define _KGETOPTDLG_H

#include <qdialog.h>
#include <qtabdlg.h>
#include <ktabctl.h>
#include "kproxydlg.h"
#include "fontdlg.h"
#include "transferdlg.h"
#include "sounddlg.h"
#include "dirdlg.h"

class KGETOptDlg : public QDialog
{
  Q_OBJECT

public:

  KGETOptDlg(QWidget *parent=0, const char *name=0, WFlags f=0);
  ~KGETOptDlg();

  // methods to access data
  void setFontData(QFont font);
  QFont dataFont() const;
  void setProxyData(QStrList *strList);
  QStrList dataProxy() const;
  void setTransferData(QStrList *strList);
  QStrList dataTransfer() const;
  void setSoundData(QStrList *strList);
  QStrList dataSound() const;
  void setDirData(QStrList *strList);
  QStrList dataDir() const;

private:

  QPushButton *help;
  QPushButton *ok;
  QPushButton *cancel;
  KTabCtl     *tabDlg;
  KProxyDlg   *prxDlg;
  FontDlg     *fntDlg;
  TransferDlg *tnfDlg;
  SoundDlg    *sndDlg;
  DirDlg      *dirDlg;

public slots:

  void helpShow();

};

#endif // _KGETOPTDLG_H
