/* $Id: kioslave_ipc.h,v 1.1.1.1 1998/05/06 19:13:37 matt Exp $
   $Log: kioslave_ipc.h,v $
   Revision 1.1.1.1  1998/05/06 19:13:37  matt
   Imported sources

   Revision 1.2  1998/03/02 14:36:27  matt
   kgetslave based on kioslave from kfm

   Revision 1.1  1998/02/16 15:59:02  matt
   *** empty log message ***


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

// This file has been created by ipcc.pl.
// (c) Torben Weis
//     weis@stud.uni-frankfurt.de

#ifndef KIOSlaveIPC_h
#define KIOSlaveIPC_h

#include <ctype.h>
#include <ksock.h>
#include <qobject.h>
#include "ipc.h"
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

class KIOSlaveIPC : public QObject
{
    Q_OBJECT
public:
    KIOSlaveIPC( char *_path );
    ~KIOSlaveIPC();

    bool isConnected();

public slots:
	void hello();
public slots:
	void progress(int _percent, int _size);
public slots:
        void startedTransfer();
public slots:
	void info(const char* _text);
public slots:
	void data(IPCMemory _text);
public slots:
	void done();
public slots:
	void fatalError(int _error, const char* _text, int _errno);
public slots:
	void setPID(int _pid);
public slots:
	void redirection(const char* _url);
signals:
	void copy(const char* _from_url, const char* _to_url, bool _overwrite);
private:
	void parse_copy( char *_data, int _len );
signals:
	void resume(const char* _from_url, const char* _to_url);
private:
	void parse_resume( char *_data, int _len );
signals:
	void getPID();
private:
	void parse_getPID( char *_data, int _len );
signals:
	void cleanUp();
private:
	void parse_cleanUp( char *_data, int _len );
public slots:
    void readEvent( KSocket * );
    void closeEvent( KSocket * );
private:
    void parse( char *_data, int _len );

    KSocket *sock;
    bool connected;
    char headerBuffer[11];
    int cHeader;
    bool bHeader;
    char *pBody;
    int cBody;
    int bodyLen;
};

#endif
