/* $Id: kioslave_ipc2.cpp,v 1.1.1.1 1998/05/06 19:13:37 matt Exp $
   $Log: kioslave_ipc2.cpp,v $
   Revision 1.1.1.1  1998/05/06 19:13:37  matt
   Imported sources

   Revision 1.2  1998/03/02 14:36:27  matt
   kgetslave based on kioslave from kfm


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

// This file has been created by ipcc.pl.
// (c) Torben Weis
//     weis@stud.uni-frankfurt.de
#include "kioslave_ipc.h"

void KIOSlaveIPC::hello()
{
	int len = 0;
	len += len_string("hello");
	write_int( sock->socket(), len );
	write_string( sock->socket(), "hello" );
}


void KIOSlaveIPC::startedTransfer()
{
	int len = 0;
	len += len_string("started");
	write_int( sock->socket(), len );
	write_string( sock->socket(), "started" );
}


void KIOSlaveIPC::progress(int _percent, int _size)
{
	int len = 0;
	len += len_int( _percent );
	len += len_int( _size );
	len += len_string("progress");
	write_int( sock->socket(), len );
	write_string( sock->socket(), "progress" );
	write_int( sock->socket(), _percent );
	write_int( sock->socket(), _size );
}

void KIOSlaveIPC::info(const char* _text)
{
	int len = 0;
	len += len_string( _text );
	len += len_string("info");
	write_int( sock->socket(), len );
	write_string( sock->socket(), "info" );
	write_string( sock->socket(), _text );
}


void KIOSlaveIPC::data(IPCMemory _text)
{
	int len = 0;
	len += len_mem( _text );
	len += len_string("data");
	write_int( sock->socket(), len );
	write_string( sock->socket(), "data" );
	write_mem( sock->socket(), _text );
}


void KIOSlaveIPC::done()
{
	int len = 0;
	len += len_string("done");
	write_int( sock->socket(), len );
	write_string( sock->socket(), "done" );
}

void KIOSlaveIPC::fatalError(int _error, const char* _text, int _errno)
{
	int len = 0;
	len += len_int( _error );
	len += len_string( _text );
	len += len_int( _errno );
	len += len_string("fatalError");
	write_int( sock->socket(), len );
	write_string( sock->socket(), "fatalError" );
	write_int( sock->socket(), _error );
	write_string( sock->socket(), _text );
	write_int( sock->socket(), _errno );
}

void KIOSlaveIPC::setPID(int _pid)
{
	int len = 0;
	len += len_int( _pid );
	len += len_string("setPID");
	write_int( sock->socket(), len );
	write_string( sock->socket(), "setPID" );
	write_int( sock->socket(), _pid );
}

void KIOSlaveIPC::redirection(const char* _url)
{
	int len = 0;
	len += len_string( _url );
	len += len_string("redirection");
	write_int( sock->socket(), len );
	write_string( sock->socket(), "redirection" );
	write_string( sock->socket(), _url );
}


void KIOSlaveIPC::parse_copy( char *_data, int _len )
{
	int pos = 0;

	// Parsing string
	const char* _from_url;
	_from_url = read_string( _data, pos, _len );
	// Parsing string
	const char* _to_url;
	_to_url = read_string( _data, pos, _len );
	// Parsing bool
	bool _overwrite;
	_overwrite = read_bool( _data, pos, _len );
	// Calling function
	emit copy( _from_url, _to_url, _overwrite );
	free( (void*)_from_url );
	free( (void*)_to_url );
}

void KIOSlaveIPC::parse_resume( char *_data, int _len )
{
	int pos = 0;

	// Parsing string
	const char* _from_url;
	_from_url = read_string( _data, pos, _len );
	// Parsing string
	const char* _to_url;
	_to_url = read_string( _data, pos, _len );
	// Calling function
	emit resume( _from_url, _to_url );
	free( (void*)_from_url );
	free( (void*)_to_url );
}


void KIOSlaveIPC::parse_getPID( char *, int  )
{
	// int pos = 0;

	// Calling function
	emit getPID(  );
}

void KIOSlaveIPC::parse_cleanUp( char *, int )
{
	// int pos = 0;

	// Calling function
	emit cleanUp(  );
}

