/* $Id: main.h,v 1.1.1.1 1998/05/06 19:13:37 matt Exp $
   $Log: main.h,v $
   Revision 1.1.1.1  1998/05/06 19:13:37  matt
   Imported sources

   Revision 1.2  1998/03/02 14:36:27  matt
   kgetslave based on kioslave from kfm


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   */

#ifndef main_h
#define main_h

#include <qobject.h>
#include <qstring.h>

#include <kurl.h>

#include <stdlib.h>
#include <unistd.h>

#include "kioslave_ipc.h"
#include "protocol.h"

class KIOSlave : public QObject
{
    Q_OBJECT
public:
    KIOSlave( char * _path );
    ~KIOSlave();

    void terminate();
    
public slots:
    /// Copy a file
    /**
      Does not copy recursive on the local file system. Copies
      from HTTP are already supported.
      */
    void copy( const char *_src_url, const char *_dest_url, bool _overwriteExistingFiles );
    void resume( const char *_src_url, const char *_dest_url );
    /// Called if a job does not need this slave any more
    /**
      Used to clear up locked tar files and close locked ftp connections.
      */    
    void cleanUp();
    /// Tells the server about the PID.
    void getPID();

    void slotRedirection( const char *_redirect );
    
protected:
    void ProcessError(KProtocol *, const char *);

    KIOSlaveIPC* ipc;

    /// The destination file we are writing to
    /**
      If the client gets a TERM signal, is closes and deletes the
      file mentioned here. It is usually the destination of a copy
      command. May be 0L.
      */
    FILE *copyDestFile;
    QString copyDestFileName;    

    QString sRedirection;
};

#endif
