#ifndef _protocol_h
#define _protocol_h

/*----------------------------------------------------
still missing:
==============
- complain if url is invalid (no such host, http:// is
  not a valid url, file:/ is perfectly legal ...)

-------------------------------------------------------*/

#ifndef _KPROTCOL_INCLUDED_
#include <kurl.h>

#include "kioslave_ipc.h"

class KProtocol : public QObject
{
    Q_OBJECT
signals:
       /**
	* Called if the given URL is redirected. For example HTTP does this by
	* sending a "Location:" line in its header. The signal is only connected to the IPC
	* mechanism during a call to @ref KIOSlave::get.
	*/
       void redirection( const char* );

    void info( int, const char* );

private:
	QString lastErrorMessage;
	int lastKError;
	int lastSysError;

protected:
	int Error(int KError, QString ErrorMessage, int SysError = 0);
	int NotImplemented();

public:
	enum Kind { READ = 1, WRITE = 2, OVERWRITE = 4,
		    APPEND = 8, RESUME = 16 }; 

	enum Status { FAIL = -1, SUCCESS = 0};

	/** functions for files/objects **/
	virtual int Open(KURL *url, int mode, unsigned long int offset=0);
	virtual long Read(void *buffer, long nbytes);
	virtual long Write(void *buffer, long nbytes);
	virtual int Close();
	virtual int atEOF();
	virtual long Size();

	/** errorhandling **/
	void GetLastError(int& KError, QString& ErrorMessage, int &SysError);

};

#define _KPROTCOL_INCLUDED_
#endif

#endif
