/* $Id: kioserver_ipc.h,v 1.1.1.1 1998/05/06 19:13:31 matt Exp $
   $Log: kioserver_ipc.h,v $
   Revision 1.1.1.1  1998/05/06 19:13:31  matt
   Imported sources

   Revision 1.1  1998/03/22 07:49:27  matt
   *** empty log message ***


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef KIOSlaveIPC_h
#define KIOSlaveIPC_h
#include <qobject.h>
#include <ksock.h>
#include <ctype.h>
#include "ipc.h"
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

class KIOSlaveIPC : public QObject
{
    Q_OBJECT
public:
    KIOSlaveIPC( KSocket * );
    ~KIOSlaveIPC();

    void parse( char *_data, int _len );

signals:
	void hello();
private:
	void parse_hello( char *_data, int _len );
signals:
	void started();
private:
	void parse_started( char *_data, int _len );
signals:
	void progress(int _percent, int _size );
private:
	void parse_progress( char *_data, int _len );
signals:
	void info(const char* _text);
private:
	void parse_info( char *_data, int _len );
signals:
	void data(IPCMemory _text);
private:
	void parse_data( char *_data, int _len );
signals:
	void done();
private:
	void parse_done( char *_data, int _len );
signals:
	void fatalError(int _error, const char* _text, int _errno);
private:
	void parse_fatalError( char *_data, int _len );
signals:
	void setPID(int _pid);
private:
	void parse_setPID( char *_data, int _len );
signals:
	void redirection(const char* _url);
private:
	void parse_redirection( char *_data, int _len );
public slots:
	void copy(const char* _from_url, const char* _to_url, bool _overwrite);
public slots:
	void resume(const char* _from_url, const char* _to_url);
public slots:
	void getPID();
public slots:
	void cleanUp();
public:
   int pid;

public slots:
   void closeEvent( KSocket* );
   void readEvent( KSocket* );
protected:
   KSocket* data_sock;
   char headerBuffer[11];
   int cHeader;
   bool bHeader;
   char *pBody;
   int cBody;
   int bodyLen;

public:
   /**
    * MODIFIED
    */
   time_t m_time;
  
signals:
   /**
    * MODIFIED
    */
   void closed( KIOSlaveIPC* );
};

class KIOSlaveIPCServer : public QObject
{
    Q_OBJECT
public:
    KIOSlaveIPCServer();
    ~KIOSlaveIPCServer();

signals:
   void newClient( KIOSlaveIPC * );

public slots:
   virtual void slotAccept( KSocket* );

protected:
   KServerSocket* serv_sock;
};

#endif
