/* $Id: kioserver_ipc2.cpp,v 1.1.1.1 1998/05/06 19:13:31 matt Exp $
   $Log: kioserver_ipc2.cpp,v $
   Revision 1.1.1.1  1998/05/06 19:13:31  matt
   Imported sources

   Revision 1.1  1998/03/22 07:49:31  matt
   *** empty log message ***


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

// This file has been created by ipcc.pl.
// (c) Torben Weis
//     weis@stud.uni-frankfurt.de

#include "kioserver_ipc.h"

void KIOSlaveIPC::parse_hello( char *, int )
{
	// int pos = 0;

	// Calling function
	emit hello(  );
}


void KIOSlaveIPC::parse_started( char *, int )
{
	// int pos = 0;

	// Calling function
	emit started(  );
}


void KIOSlaveIPC::parse_progress( char *_data, int _len )
{
	int pos = 0;

	// Parsing int
	int _percent;
	_percent = read_int( _data, pos, _len );
	int _size;
	_size = read_int( _data, pos, _len );

	// Calling function
	emit progress( _percent, _size );
}

void KIOSlaveIPC::parse_info( char *_data, int _len )
{
	int pos = 0;

	// Parsing string
	const char* _text;
	_text = read_string( _data, pos, _len );
	// Calling function
	emit info( _text );
	free( (void*)_text );
}


void KIOSlaveIPC::parse_data( char *_data, int _len )
{
	int pos = 0;

	// Parsing mem
	IPCMemory _text;
	_text = read_mem( _data, pos, _len );
	// Calling function
	emit data( _text );
	free( (void*)_text.data );
}


void KIOSlaveIPC::parse_done( char *, int )
{
	// int pos = 0;

	// Calling function
	emit done(  );
}

void KIOSlaveIPC::parse_fatalError( char *_data, int _len )
{
	int pos = 0;

	// Parsing int
	int _error;
	_error = read_int( _data, pos, _len );
	// Parsing string
	const char* _text;
	_text = read_string( _data, pos, _len );
	// Parsing int
	int _errno;
	_errno = read_int( _data, pos, _len );
	// Calling function
	emit fatalError( _error, _text, _errno );
	free( (void*)_text );
}

void KIOSlaveIPC::parse_setPID( char *_data, int _len )
{
	int pos = 0;

	// Parsing int
	int _pid;
	_pid = read_int( _data, pos, _len );
	// Calling function
	emit setPID( _pid );
}

void KIOSlaveIPC::parse_redirection( char *_data, int _len )
{
	int pos = 0;

	// Parsing string
	const char* _url;
	_url = read_string( _data, pos, _len );
	// Calling function
	emit redirection( _url );
	free( (void*)_url );
}


void KIOSlaveIPC::copy(const char* _from_url, const char* _to_url, bool _overwrite)
{
	int len = 0;
	len += len_string( _from_url );
	len += len_string( _to_url );
	len += len_bool( _overwrite );
	len += len_string("copy");
	write_int( data_sock->socket(), len );
	write_string( data_sock->socket(), "copy" );
	write_string( data_sock->socket(), _from_url );
	write_string( data_sock->socket(), _to_url );
	write_bool( data_sock->socket(), _overwrite );
}

void KIOSlaveIPC::resume(const char* _from_url, const char* _to_url)
{
	int len = 0;
	len += len_string( _from_url );
	len += len_string( _to_url );
	len += len_string("resume");
	write_int( data_sock->socket(), len );
	write_string( data_sock->socket(), "resume" );
	write_string( data_sock->socket(), _from_url );
	write_string( data_sock->socket(), _to_url );
}


void KIOSlaveIPC::getPID()
{
	int len = 0;
	len += len_string("getPID");
	write_int( data_sock->socket(), len );
	write_string( data_sock->socket(), "getPID" );
}

void KIOSlaveIPC::cleanUp()
{
	int len = 0;
	len += len_string("cleanUp");
	write_int( data_sock->socket(), len );
	write_string( data_sock->socket(), "cleanUp" );
}

