/* $Id: kmytablistbox.cpp,v 1.1.1.1 1998/05/06 19:13:32 matt Exp $
   $Log: kmytablistbox.cpp,v $
   Revision 1.1.1.1  1998/05/06 19:13:32  matt
   Imported sources


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   */
#include <kmsgbox.h>
#include <klocale.h>
#include <kiconloader.h>
#include <kstring.h>
#include <kapp.h>

#include "kmytablistbox.h"

#define SIZE_PIXMAP  26
#define SIZE_PERCENT 30
#define SIZE_SIZE    74

QList<QPixmap> *KMyTabListBox::animConn;
QList<QPixmap> *KMyTabListBox::animTry;
QPixmap *KMyTabListBox::pixDisconn;
QPixmap *KMyTabListBox::pixTryLater;


KMyTabListBox::KMyTabListBox (QWidget *parent, const char *name, 
			      int columns, WFlags f)
  : KTabListBox (parent, name, columns, f)
{
  setColumn(0, "S", SIZE_PIXMAP, PixmapColumn);
  setColumn(2, "%", SIZE_PERCENT);
  setColumn(3, i18n("Size"), SIZE_SIZE);

  setColumn(1, i18n("File Name"),
	    parent->width() - SIZE_SIZE - SIZE_PERCENT - SIZE_PIXMAP );

  QString path = KApplication::getKApplication()->kde_datadir() + "/kget/pics/";

  // Load animations
  if ( animConn->count() == 0 )
    {
      animConn->setAutoDelete( true );
      animTry->setAutoDelete( true );
      for ( int i = 0; i < 7; i++ )
	{
	  QString n1;

	  QPixmap *p1 = new QPixmap();
	  n1.sprintf( "/connect%i.xpm", i );
	  p1->load( path + n1 );
	  if ( p1->isNull() ) {
	    QString e;
	    e << i18n( "Could not load icon\n" ) << n1.data();
	    KMsgBox::message( this, i18n( "KGet Error" ), e.data(),
			      KMsgBox::EXCLAMATION );
	  }
	  animConn->append( p1 );
	  n1.sprintf( "connect%i", i );
	  dict().insert( n1, p1);

	  p1 = new QPixmap();
	  n1.sprintf( "/try%i.xpm", i );
	  p1->load( path + n1 );
	  if ( p1->isNull() ) {
	    QString e;
	    e << i18n( "Could not load icon\n" ) << n1.data();
	    KMsgBox::message( this, i18n( "KGet Error" ), e.data(),
			      KMsgBox::EXCLAMATION);
	  }
	  animTry->append( p1 );
	  n1.sprintf( "try%i", i );
	  dict().insert( n1, p1);
	}
    }

  pixDisconn = new QPixmap();
  pixDisconn->load(path + "try0.xpm");
  dict().insert("disconnect", pixDisconn);

  pixTryLater = new QPixmap();
  pixTryLater->load(path + "later.xpm");
  dict().insert("later", pixTryLater);

  phasesNum = animConn->count();
}



KMyTabListBox::~KMyTabListBox()
{
}


void KMyTabListBox::resizeEvent ( QResizeEvent* e ) {

  KTabListBox::resizeEvent( e );
  
  setColumn(1, i18n("File Name"),
 	    width() - SIZE_SIZE - SIZE_PERCENT - SIZE_PIXMAP );

}
