/* $Id: kmytablistbox.h,v 1.1.1.1 1998/05/06 19:13:31 matt Exp $
   $Log: kmytablistbox.h,v $
   Revision 1.1.1.1  1998/05/06 19:13:31  matt
   Imported sources


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   */

#ifndef KMyTabListBox_h
#define KMyTabListBox_h

#include <ktablistbox.h>

class KMyTabListBox : public KTabListBox
{
  Q_OBJECT

public:
  KMyTabListBox (QWidget *parent=0, const char *name=0, 
	       int columns=1, WFlags f=0);
  virtual ~KMyTabListBox();

  uint getPhasesNum() { return phasesNum; }

  /*
     * hack to get static classes up and running even with C++-Compilers/
     * Systems where a constructor of a class element declared static
     * would never get called (Aix, Alpha,...). In the next versions these
     * elements should disappear.
     */
  static void InitStatic() {
    animConn = new QList<QPixmap>;
    animTry = new QList<QPixmap>;
    pixDisconn = new QPixmap;
    pixTryLater = new QPixmap;
  }

protected:

  static QList<QPixmap> *animConn;
  static QList<QPixmap> *animTry;
  static QPixmap *pixDisconn;
  static QPixmap *pixTryLater;

  uint phasesNum;

  virtual void resizeEvent ( QResizeEvent* );

};


#endif /*KMyTabListBox_h*/
