/* $Id: kproxydlg.h,v 1.1.1.1 1998/05/06 19:13:31 matt Exp $
   $Log: kproxydlg.h,v $
   Revision 1.1.1.1  1998/05/06 19:13:31  matt
   Imported sources

   Revision 1.1  1998/03/22 07:27:40  matt
   Added i18n


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   */

#ifndef _KPROXYDLG_H
#define _KPROXYDLG_H

#include <qgrpbox.h> 
#include <qpushbt.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qlined.h>
#include <qchkbox.h>

class KProxyDlg : public QWidget
{
Q_OBJECT
  public:
    KProxyDlg(QWidget *parent=0, const char *name=0, WFlags f=0);
    ~KProxyDlg();

    void setData(QStrList *strList);
    QStrList data() const;
     
  private:
    bool useProxy;

    QGroupBox *box;
    
    // ftp proxy fields
    QLabel *lb_ftp_url;		// label ftp url
    QLineEdit *le_ftp_url;	// lineedit ftp url
    QLabel *lb_ftp_port;	// and so on :)
    QLineEdit *le_ftp_port;

    // http proxy fields
    QLabel *lb_http_url;
    QLineEdit *le_http_url;
    QLabel *lb_http_port;
    QLineEdit *le_http_port;  

    // "no proxy for" fields
    QLabel *lb_no_prx;
    QLineEdit *le_no_prx;

    // copy down butto
    QPushButton *cp_down;
    // use proxy checker
    QCheckBox *cb_useProxy;

    void setProxy();
    
  public slots:
    void copyDown();		// use the http setting for all services
    void changeProxy();
};

#endif // __KPROXYDLG_H
