/* $Id: ksavedialog.cpp,v 1.1.1.1 1998/05/06 19:13:31 matt Exp $
   $Log: ksavedialog.cpp,v $

   Revision 1.1  1998/01/28 13:50:23  matt
   *** empty log message ***


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <kmsgbox.h>
#include <kiconloader.h>
#include <klocale.h>

#include "ksavedialog.h"
#include "kquestiondialog.h"

#define Inherited QDialog

KSaveDialog::KSaveDialog
(
   QWidget* parent,
   QString currentDir,
   QString currentFile,
   QString _dir1,
   QString _dir2,
   QString _dir3,
   QString _dir4
   )
    :
    Inherited( parent, "", TRUE, 0 )
{
  
  dir1 = _dir1;
  dir2 = _dir2;
  dir3 = _dir3;
  dir4 = _dir4;

  dirName = new QLineEdit( this, "dirLineEdit" );
  dirName->setGeometry( 10, 10, 220, 30 );
  connect( dirName, SIGNAL(returnPressed()), SLOT(slotDirEntered()) );
  dirName->setText( "" );
  dirName->setMaxLength( 32767 );
  dirName->setEchoMode( QLineEdit::Normal );
  dirName->setFrame( TRUE );

  upDirPushButton = new QPushButton( this, "updirPushButton" );
  upDirPushButton->setGeometry( 240, 10, 30, 30 );
  connect( upDirPushButton, SIGNAL(clicked()), SLOT(slotUpDir()) );
  upDirPushButton->setText( "" );
  upDirPushButton->setAutoRepeat( FALSE );

  mkdirPushButton = new QPushButton( this, "mkdirPushButton" );
  mkdirPushButton->setGeometry( 280, 10, 30, 30 );
  connect( mkdirPushButton, SIGNAL(clicked()), SLOT(slotMkDir()) );
  mkdirPushButton->setText( "" );
  mkdirPushButton->setAutoRepeat( FALSE );

  fileList = new QListBox( this, "dirListBox" );
  fileList->setGeometry( 10, 50, 340, 165 );
  connect( fileList, SIGNAL(selected(int)), SLOT(slotItemSelected(int)) );
  fileList->setFrameStyle( 51 );
  fileList->setLineWidth( 2 );
  fileList->setMultiSelection( FALSE );

  fileName = new QLineEdit( this, "fileLineEdit" );
  fileName->setGeometry( 10, 225, 220, 30 );
  connect( fileName, SIGNAL(returnPressed()), SLOT(slotSave()) );
  fileName->setText( "" );
  fileName->setEchoMode( QLineEdit::Normal );
  fileName->setFrame( TRUE );

  QPushButton* dlgedit_savePushButton;
  dlgedit_savePushButton = new QPushButton( this, "savePushButton" );
  dlgedit_savePushButton->setGeometry( 240, 225, 50, 30 );
  connect( dlgedit_savePushButton, SIGNAL(clicked()), SLOT(slotSave()) );
  dlgedit_savePushButton->setText( "Save" );
  dlgedit_savePushButton->setAutoRepeat( FALSE );

  QPushButton* dlgedit_cancelPushButton;
  dlgedit_cancelPushButton = new QPushButton( this, "cancelPushButton" );
  dlgedit_cancelPushButton->setGeometry( 300, 225, 50, 30 );
  connect( dlgedit_cancelPushButton, SIGNAL(clicked()), SLOT(slotCancel()) );
  dlgedit_cancelPushButton->setText( "Cancel" );
  dlgedit_cancelPushButton->setAutoRepeat( FALSE );

  homePushButton = new QPushButton( this, "homePushButton" );
  homePushButton->setGeometry( 320, 10, 30, 30 );
  connect( homePushButton, SIGNAL(clicked()), SLOT(slotHomeDir()) );
  homePushButton->setText( "" );
  homePushButton->setAutoRepeat( FALSE );

  dir1Button = new QPushButton( this, "dir1button");
  dir1Button->setGeometry(360, 60, 30, 30);
  dir1Button->setText("1");
  dir1Button->setAutoRepeat( FALSE );
  connect( dir1Button, SIGNAL(clicked()), SLOT(slotFastDir1()));

  dir2Button = new QPushButton( this, "dir2button");
  dir2Button->setGeometry(360, 100, 30, 30);
  dir2Button->setText("2");
  dir2Button->setAutoRepeat( FALSE );
  connect( dir2Button, SIGNAL(clicked()), SLOT(slotFastDir2()));

  dir3Button = new QPushButton( this, "dir3button");
  dir3Button->setGeometry(360, 140, 30, 30);
  dir3Button->setText("3");
  dir3Button->setAutoRepeat( FALSE );
  connect( dir3Button, SIGNAL(clicked()), SLOT(slotFastDir3()));

  dir4Button = new QPushButton( this, "dir4button");
  dir4Button->setGeometry(360, 180, 30, 30);
  dir4Button->setText("4");
  dir4Button->setAutoRepeat( FALSE );
  connect( dir4Button, SIGNAL(clicked()), SLOT(slotFastDir4()));

  resize( 400,270 );
  setMinimumSize( 400, 270 );
  setMaximumSize( 400, 270 );

  KIconLoader *loader = KApplication::getKApplication()->getIconLoader();

  QPixmap pixmap;

  pixmap = loader->loadIcon("up.xpm");
  upDirPushButton->setPixmap( pixmap );
  pixmap = loader->loadIcon("fileopen.xpm");
  mkdirPushButton->setPixmap( pixmap );
  pixmap = loader->loadIcon("home.xpm");
  homePushButton->setPixmap( pixmap );

  setCaption( "Save As" );
  if ( currentDir )
    d.setPath( currentDir );
  if ( currentFile )
    fileName->setText( currentFile );
  
  d.convertToAbs();
  rereadDir();

  fileName->setFocus();
}


KSaveDialog::~KSaveDialog()
{
}


void KSaveDialog::slotCancel() {
  reject();
}


void KSaveDialog::slotSave() {
  if ( strcmp( fileName->text(), "") != 0 ) {
    accept();
  }
}



void KSaveDialog::slotHomeDir() {
  d = d.home();
  rereadDir();
}


void KSaveDialog::slotFastDir1() {
  if (! dir1.isEmpty() ) {
    d.cd( dir1 );
    rereadDir();
  }
}


void KSaveDialog::slotFastDir2() {
  if (! dir2.isEmpty() ) {
    d.cd( dir2 );
    rereadDir();
  }
}


void KSaveDialog::slotFastDir3() {
  if (! dir3.isEmpty() ) {
    d.cd( dir3 );
    rereadDir();
  }
}


void KSaveDialog::slotFastDir4() {
  if (! dir4.isEmpty() ) {
    d.cd( dir4 );
    rereadDir();
  }
}


void KSaveDialog::slotUpDir() {
  d.cd( ".." );
  rereadDir();
}


void KSaveDialog::slotMkDir() {
  KQuestionDialog *box = new KQuestionDialog("Make directory :", this);

  QString newdir;

  box->show();

  if (!box->result())   /* cancelled */
    return;

  newdir = box->getAnswer();
  delete box;

  if ( newdir.isEmpty() ) /* answer is "" */
    return;

  if (! d.mkdir( newdir ))
    KMsgBox::message( this,
		      i18n("Sorry"),
		      i18n("Cannot make directory."));
  rereadDir();
}


void KSaveDialog::slotItemSelected( int index ) {
  QDir tmp = d;
  QString text( fileList->text(index) );

  if ( text.right(1) == d.separator() )
    text = text.left( text.length() - 1);

  QFileInfo fi( QString(d.path()) + d.separator()  + text );

  if ( fi.isDir() ) {
    if ( d.cd( text ) && d.isReadable() ) {
      rereadDir();
    } else {
      KMsgBox::message( this, "Sorry", "Cannot open or read directory." );
      d = tmp;
    }
  } else if ( fi.isFile() ) {
    fileName->setText( text );
  }
}


void KSaveDialog::rereadDir() {
  KApplication *app = KApplication::getKApplication();

  app->setOverrideCursor( waitCursor );
  fileList ->setAutoUpdate( FALSE );
  fileList->clear();

  const QFileInfoList *filist = d.entryInfoList( QDir::All, QDir::DirsFirst);
  if ( filist ) {
    QFileInfoListIterator it( *filist );
    QFileInfo *fi = it.current();
    while ( fi ) {
      if ( fi->isDir() ) {
	fileList->insertItem( QString(fi->fileName().data()) 
			      + d.separator());
      } else {
	fileList->insertItem( fi->fileName().data() );
      }
      fi = ++it;
    }
    dirName->setText( d.path() );
  } else {
    app->restoreOverrideCursor();
    KMsgBox::message( this, "Sorry", "Cannot open or read directory." );
    app->setOverrideCursor( waitCursor );
  }
  fileList->setAutoUpdate( TRUE );
  fileList->repaint();
  app->restoreOverrideCursor();
}


QString KSaveDialog::fileSelected() const {
  QString tmp;
  if ( fileName->text() && strcmp( fileName->text(), "" ) != 0 )
    tmp = fileName->text();
  
  return tmp;
}


QString KSaveDialog::dirEntered() const {
  QString tmp;
  if ( dirName->text() && strcmp( dirName->text(), "" ) != 0 )
    tmp = dirName->text();
  
  return tmp;
}


void KSaveDialog::slotDirEntered() {
  d.cd( dirName->text() );
  rereadDir();
}
