/* $Id: transferdlg.cpp,v 1.1.1.1 1998/05/06 19:13:31 matt Exp $
   $Log: transferdlg.cpp,v $
   Revision 1.1.1.1  1998/05/06 19:13:31  matt
   Imported sources

   Revision 1.2  1998/03/22 07:27:24  matt
   Added i18n

   Revision 1.1  1998/02/18 16:38:03  matt
   *** empty log message ***


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <klocale.h>
#include <kapp.h>
#include "transferdlg.h"


TransferDlg::TransferDlg(QWidget *parent, const char *name, WFlags f)
  : QWidget(parent, name, f)
{

  box = new QGroupBox(this, "box");
  box->setGeometry(10,10,365,280);
  box->setTitle(i18n("Transfer Options"));

  cb_useQueueing = new QCheckBox(i18n("Use queueing"), this );
  cb_useQueueing->setGeometry( 20, 40, 120, 30 );
  connect( cb_useQueueing, SIGNAL( clicked() ), SLOT( changeQueueing() ) );
  
  lb_queueing = new QLabel(i18n("Maximum number of opened connections :"), this);
  lb_queueing->setAlignment(AlignLeft | AlignVCenter);
  lb_queueing->setGeometry(40, 70, 260, 30);
  le_maxnum = new QLineEdit(this);
  le_maxnum->setGeometry(290, 70, 30, 30);

  cb_showSpeed = new QCheckBox(i18n("Show speed for PPP link"), this );
  cb_showSpeed->setGeometry( 20, 120, 160, 30 );
  connect( cb_showSpeed, SIGNAL( clicked() ), SLOT( changeSpeed() ) );

  lb_speed = new QLabel(i18n("Update after"), this);
  lb_speed->setAlignment(AlignLeft | AlignVCenter);
  lb_speed->setGeometry(40, 150, 90, 30);
  le_speed_int = new QLineEdit(this);
  le_speed_int->setGeometry(120, 150, 45, 30);

  lb_seconds2 = new QLabel(i18n("seconds"), this);
  lb_seconds2->setAlignment(AlignLeft | AlignVCenter);
  lb_seconds2->setGeometry(170, 150, 55, 30);

  lb_link = new QLabel(i18n("PPP link :"), this);
  lb_link->setAlignment(AlignLeft | AlignVCenter);
  lb_link->setGeometry(240, 150, 60, 30);
  le_link_number = new QLineEdit(this);
  le_link_number->setGeometry(300, 150, 30, 30);

  lb_disconnect = new QLabel(i18n("Disconnect command :"), this);
  lb_disconnect->setAlignment(AlignLeft | AlignVCenter);
  lb_disconnect->setGeometry(40, 220, 130, 30);
  le_disconnect = new QLineEdit(this);
  le_disconnect->setGeometry(175, 220, 180, 30);
  
//   cb_useReconnecting = new QCheckBox(i18n("Use reconnecting"), this );
//   cb_useReconnecting->setGeometry( 20, 200, 150, 30 );
//   connect( cb_useReconnecting, SIGNAL( clicked() ), SLOT( changeReconnecting() ) );
//   lb_reconnecting = new QLabel(i18n("Reconnect after"), this);
//   lb_reconnecting->setAlignment(AlignLeft | AlignVCenter);
//   lb_reconnecting->setGeometry(40, 230, 110, 30);
//   le_aftertime = new QLineEdit(this);
//   le_aftertime->setGeometry(140, 230, 45, 30);

//   lb_seconds = new QLabel(i18n("seconds"), this);
//   lb_seconds->setAlignment(AlignLeft | AlignVCenter);
//   lb_seconds->setGeometry(190, 230, 55, 30);

}


TransferDlg::~TransferDlg()
{
  // now delete everything we allocated before
  delete box;

  delete cb_useQueueing;
  delete lb_queueing;
  delete le_maxnum;

//   delete cb_useReconnecting;
//   delete lb_reconnecting;
//   delete le_aftertime;
//   delete lb_seconds;

  delete cb_showSpeed;
  delete lb_speed;
  delete le_speed_int;
  delete lb_seconds2;
  delete lb_link;
  delete le_link_number;

  delete lb_disconnect;
  delete le_disconnect;

  // time to say goodbye ...
}


void TransferDlg::setQueueing()
{
  // now set all input fields
  le_maxnum->setEnabled( useQueueing );
  cb_useQueueing->setChecked( useQueueing );
}

void TransferDlg::changeQueueing()
{
  useQueueing = (! useQueueing);
  setQueueing();
}


// void TransferDlg::setReconnecting()
// {
//   // now set all input fields
//   le_aftertime->setEnabled( useReconnecting );
//   cb_useReconnecting->setChecked( useReconnecting );
// }

// void TransferDlg::changeReconnecting()
// {
//   useReconnecting = (! useReconnecting);
//   setReconnecting();
// }

void TransferDlg::changeSpeed()
{
  showSpeed = (! showSpeed);
  setSpeed();
}

void TransferDlg::setSpeed()
{
  // now set all input fields
  le_speed_int->setEnabled( showSpeed );
  le_link_number->setEnabled( showSpeed );
  cb_showSpeed->setChecked( showSpeed );
}


void TransferDlg::setData(QStrList *strList)
{
  QString tmp;

  tmp = strList->first();
  if( tmp == "Yes" ) {
    useQueueing = TRUE;
  } else {
    useQueueing = FALSE;
  }
  setQueueing();
  
  tmp = strList->next();
  if ( ! tmp.isEmpty() ) {
    printf("Maximum number of connections found in kgetrc!\n");
    le_maxnum->setText( tmp.data() );
  }
  
  tmp = strList->next();
  if( tmp == i18n("Yes") ) {
    useReconnecting = TRUE;
  } else {
    useReconnecting = FALSE;
  }
//   setReconnecting();
  
  tmp = strList->next();
  if ( ! tmp.isEmpty() ) {
    printf("Reconnecting time found in kgetrc!\n");
//     le_aftertime->setText( tmp.data() );
  }

  tmp = strList->next();
  if( tmp == "Yes" ) {
    showSpeed = TRUE;
  } else {
    showSpeed = FALSE;
  }
  setSpeed();
  
  tmp = strList->next();
  if ( ! tmp.isEmpty() ) {
    printf("Stats update found in kgetrc!\n");
    le_speed_int->setText( tmp.data() );
  }

  tmp = strList->next();
  if ( ! tmp.isEmpty() ) {
    printf("PPP link number found in kgetrc!\n");
    le_link_number->setText( tmp.data() );
  }

  tmp = strList->next();
  if ( ! tmp.isEmpty() ) {
    printf("Disconnect command found in kgetrc!\n");
    le_disconnect->setText( tmp.data() );
  }
}

static QStrList strList(true);

QStrList TransferDlg::data() const
{
  strList.clear();
  QString tmp;
  
  if( useQueueing == TRUE ) {
    strList.append( "Yes" );
  } else {
    strList.append( "No" );
  }
  
  tmp = le_maxnum->text();
  if( tmp.isEmpty() ) {
    printf("No maximum number of connections selected!\n");
    strList.append("");
  } else {
    strList.append( tmp.data() );
  }

  if( useReconnecting == TRUE ) {
    strList.append( "Yes" );
  } else {
    strList.append( "No" );
  }
  
  tmp = "";//le_aftertime->text();
  if( tmp.isEmpty() ) {
    printf("No reconnecting time selected!\n");
    strList.append("");
  } else {
    strList.append( tmp.data() );
  }

  if( showSpeed == TRUE ) {
    strList.append( "Yes" );
  } else {
    strList.append( "No" );
  }
  
  tmp = le_speed_int->text();
  if( tmp.isEmpty() ) {
    printf("No stats update time selected!\n");
    strList.append("");
  } else {
    strList.append( tmp.data() );
  }

  tmp = le_link_number->text();
  if( tmp.isEmpty() ) {
    printf("No PPP link number selected!\n");
    strList.append("");
  } else {
    strList.append( tmp.data() );
  }

  tmp = le_disconnect->text();
  if( tmp.isEmpty() ) {
    printf("No disconnect command selected!\n");
    strList.append("");
  } else {
    strList.append( tmp.data() );
  }

  return strList;
}

