/* $Id: transferdlg.h,v 1.1.1.1 1998/05/06 19:13:32 matt Exp $
   $Log: transferdlg.h,v $
   Revision 1.1.1.1  1998/05/06 19:13:32  matt
   Imported sources


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   */

#ifndef _TRANSFERDLG_H
#define _TRANSFERDLG_H

#include <qgrpbox.h> 
#include <qwidget.h>
#include <qlabel.h>
#include <qlined.h>
#include <qchkbox.h>

class TransferDlg : public QWidget
{
  Q_OBJECT

public:

  TransferDlg(QWidget *parent=0, const char *name=0, WFlags f=0);
  ~TransferDlg();

  void setData(QStrList *strList);
  QStrList data() const;
     
private:

  bool useQueueing;
  bool showSpeed;
  bool useReconnecting;

  QGroupBox *box;
    
  // queueing fields
  QCheckBox *cb_useQueueing;
  QLabel *lb_queueing;	// label queueing
  QLineEdit *le_maxnum;	// lineedit maxnum

  // speed fields
  QCheckBox *cb_showSpeed;
  QLabel *lb_speed;
  QLineEdit *le_speed_int;
  QLabel *lb_seconds2;
  QLabel *lb_link;
  QLineEdit *le_link_number;

  //     // reconnecting fields
  //     QCheckBox *cb_useReconnecting;
  //     QLabel *lb_reconnecting;
  //     QLineEdit *le_aftertime;
  //     QLabel *lb_seconds;

  // disconnect command
  QLabel *lb_disconnect;
  QLineEdit *le_disconnect;

  void setQueueing();
  void setSpeed();
  //     void setReconnecting();
  void setDisconnect();


public slots:

  void changeQueueing();
  void changeSpeed();
  //     void changeReconnecting();

};

#endif // __TRANSFERDLG_H
