#ifndef _MSGWINDOW_
#define _MSGWINDOW_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpushbt.h>
#include <qgrpbox.h>
#include <qdialog.h>
#include <qlined.h>
#include <qlabel.h>
#include <qmlined.h>
#include "wrapedit.h"

class MsgWindow : public QDialog {
  Q_OBJECT
public:
  MsgWindow(const char*, unsigned long, const char*, const char*);
  ~MsgWindow();
  void setUIN(unsigned long);
  void setName(const char*);
  void setEMail(const char*);
  void setMessage(const char*);
  long seq();
  void stopCommand();
  void saveHistory();
public slots:
signals:
protected:
  unsigned long uin;
  QString message;
  QPushButton *sendbutton, *cancelbutton;
  QGroupBox *tobox;
  QLabel *uinlabel, *handlelabel, *emaillabel;
  QLineEdit *uinline, *handleline, *emailline;
  QPushButton *infobutton;
  QLabel *editlabel;
  WrapEdit *editbox;
  QLabel *updateanim;
  long sendSeq;
  void resizeEvent(QResizeEvent *);
  void closeEvent(QCloseEvent *);
protected slots:
  void sendMessage();
  void cancelMessage();
  void infoRequest();
private:
private slots:
};
#endif /* _MSGWINDOW_ */
