#ifndef _URLSNDWIN_
#define _URLSNDWIN_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpushbt.h>
#include <qgrpbox.h>
#include <qdialog.h>
#include <qlined.h>
#include <qlabel.h>
#include <qmlined.h>

class URLSndWindow : public QDialog {
  Q_OBJECT
public:
  URLSndWindow(const char*, unsigned long, const char*);
  ~URLSndWindow();
  void setUIN(unsigned long);
  void setName(const char*);
  void setEMail(const char*);
  long seq();
  void stopCommand();
  void saveHistory();
public slots:
signals:
protected:
  unsigned long uin;
  QString message;
  QPushButton *sendbutton, *cancelbutton;
  QGroupBox *tobox;
  QLabel *uinlabel, *handlelabel, *emaillabel;
  QLineEdit *uinline, *handleline, *emailline;
  QPushButton *infobutton;
  QLabel *editlabel, *urllabel;
  QMultiLineEdit *editbox;
  QLineEdit *urlbox;
  QLabel *updateanim;
  long sendSeq;
  void resizeEvent(QResizeEvent *);
  void closeEvent(QCloseEvent *);
protected slots:
  void sendURL();
  void cancelURL();
  void infoRequest();
private:
private slots:
};
#endif /* _URLSNDWIN_ */
