/*  
 *  This file is part of kISDN, Copyright (C) 1998 by
 *
 *  Thorsten Westheider <twesthei@phya1.physik.uni-bielefeld.de>
 *  Carsten Pfeiffer <carpdjih@sp.zrz.tu-berlin.de>
 *
 ****************************************************************/
 
// $Id: connection.h,v 1.2 1998/11/21 12:35:08 twesthei Exp $
//
// $Log: connection.h,v $
// Revision 1.2  1998/11/21 12:35:08  twesthei
// Free edition is compiling and running at first glance; DoD
// seems to be broken, but it is also in the Professional Edition...
// I suppose, this has something to do with Kernel 2.0.36 (i.e.
// HiSax 3.1), since there seems to be a new ioctl for locking/
// unlocking DoD...gotta explore this matter.
//
// Revision 1.1.1.1  1998/11/21 10:18:58  twesthei
// Imported sources

 
#ifndef __CONNECTION_H
#define __CONNECTION_H

#include <qwidget.h>	// Why the heck was QWidget needed ???

#include <kprocess.h>

#include "isdnconfig.h"
#include "isdnctrl.h"
#include "kisdndata.h"
#include "netctrl.h"


class Connection : public QWidget
{
  private:
  
    KProcess     *IPPPD;
    ushort       devindex;
    ISDNCtrl     *isdnctrl;
    ISDNConfig   *isdnconfig;
    NetCtrl      *netctrl;
    ushort       encaps;
    char         condev[8], conslave[8];
    
    void  createInterface(AccountData *, const char *);
    void  deleteInterface();
    bool  writeScripts(AccountData *);
  
    void  messageCantOpenFile(const char *);
    void  messageNoDNSSupplied();
  
  public:
  
    Connection(AccountData *, char *, char *, NetCtrl *, ISDNCtrl *, ISDNConfig *,
               QWidget *parent = 0, const char *name = 0);
    ~Connection();
  
    void  dialOut();
    void  hangUp();
};

#endif
