/*  
 *  This file is part of kISDN, Copyright (C) 1998 by
 *
 *  Thorsten Westheider <twesthei@phya1.physik.uni-bielefeld.de>
 *  Carsten Pfeiffer <carpdjih@sp.zrz.tu-berlin.de>
 *
 ****************************************************************/
 
// $Id: dodbutton.h,v 1.2 1998/11/21 12:35:11 twesthei Exp $
//
// $Log: dodbutton.h,v $
// Revision 1.2  1998/11/21 12:35:11  twesthei
// Free edition is compiling and running at first glance; DoD
// seems to be broken, but it is also in the Professional Edition...
// I suppose, this has something to do with Kernel 2.0.36 (i.e.
// HiSax 3.1), since there seems to be a new ioctl for locking/
// unlocking DoD...gotta explore this matter.
//
// Revision 1.1.1.1  1998/11/21 10:18:58  twesthei
// Imported sources

 
#ifndef __DODBUTTON_H
#define __DODBUTTON_H

#include "isdnconfig.h"
#include "ledbutton.h"


class DoDButton : public LEDPushButton
{
  Q_OBJECT
  
  private:
  
    ISDNConfig  *isdnconfig;

  public:
  
    DoDButton(ISDNConfig *, QWidget *parent = 0, const char *name = 0);

  signals:
  
    void  sigDoDChanged(bool);
  
  public slots:

    void  slotDoDPressed()      { emit sigDoDChanged(!isActive()); }

    void  slotDisable(ushort);
    void  slotDisengaged() 	{ setActive(false); }
    void  slotEnable(ushort);
    void  slotEngaged()    	{ setActive(true);  }
};


#endif
