/*
 *  This file is part of kISDN, Copyright (C) 1998 by
 *
 *  Thorsten Westheider <twesthei@phya1.physik.uni-bielefeld.de>
 *  Carsten Pfeiffer <carpdjih@sp.zrz.tu-berlin.de>
 *
 ****************************************************************/

// $Id: ledbutton.h,v 1.2 1998/11/21 12:35:24 twesthei Exp $
//
// $Log: ledbutton.h,v $
// Revision 1.2  1998/11/21 12:35:24  twesthei
// Free edition is compiling and running at first glance; DoD
// seems to be broken, but it is also in the Professional Edition...
// I suppose, this has something to do with Kernel 2.0.36 (i.e.
// HiSax 3.1), since there seems to be a new ioctl for locking/
// unlocking DoD...gotta explore this matter.
//
// Revision 1.1.1.1  1998/11/21 10:18:58  twesthei
// Imported sources


#ifndef __LEDBUTTON_H
#define __LEDBUTTON_H

#include <qcolor.h>
#include <qpainter.h>
#include <qpushbt.h>


class LEDPushButton : public QPushButton
{
  Q_OBJECT
  
  private:
  
    QColor  _dark, _light;
    bool    _active, _fixed;	// _fixed relates to LED sizing
    int     _xshift, _yshift;
    
  protected:
  
    void  drawButtonLabel(QPainter *);

  public:
  
    LEDPushButton(const QColor& dark, const QColor& light, bool fixed = false, QWidget *parent = 0, 
                  const char *name = 0) : QPushButton(parent, name), 
		                          _dark(dark), 
					  _light(light), 
		                          _active(false), 
					  _fixed(fixed), 
					  _xshift(0),
					  _yshift(0) {}
					  
    LEDPushButton(const char *text, const QColor& dark, const QColor& light, bool fixed = false,
                  QWidget *parent = 0, const char *name = 0) : QPushButton(text, parent, name), 
		                                               _dark(dark), 
							       _light(light), 
							       _active(false), 
							       _fixed(fixed), 
					  		       _xshift(0),
					                       _yshift(0) {}
    ~LEDPushButton() {}
    
    bool  isActive() const  { return _active;         }
    void  setActive(bool b) { _active = b; repaint(); }
    
    void  shiftPixmap(int, int);
};


#endif
