/*  
 *  This file is part of kISDN, Copyright (C) 1998 by
 *
 *  Thorsten Westheider <twesthei@phya1.physik.uni-bielefeld.de>
 *  Carsten Pfeiffer <carpdjih@sp.zrz.tu-berlin.de>
 *
 ****************************************************************/
 
// $Id: rectled.cpp,v 1.2 1998/11/21 12:34:56 twesthei Exp $
//
// $Log: rectled.cpp,v $
// Revision 1.2  1998/11/21 12:34:56  twesthei
// Free edition is compiling and running at first glance; DoD
// seems to be broken, but it is also in the Professional Edition...
// I suppose, this has something to do with Kernel 2.0.36 (i.e.
// HiSax 3.1), since there seems to be a new ioctl for locking/
// unlocking DoD...gotta explore this matter.
//
// Revision 1.1.1.1  1998/11/21 10:18:58  twesthei
// Imported sources

 
#include <qpainter.h> 
 
#include "rectled.h"


RectLED::RectLED(const QColor& dark, const QColor& light, QWidget *parent, const char *name, 
                 int w, int h) : QFrame(parent, name),
		 		 _light(light),
				 _dark(dark),
				 _state(false)
{
  resize(w, h);
  setLineWidth(2);
  setFrameStyle(QFrame::Panel | QFrame::Sunken);
  
  _rect = QRect(2, 2, w-4, h-4);
  repaint();
}


/*
 * Private methods
 ******************/
 
void  RectLED::paintEvent(QPaintEvent *ev)
{
  QBrush    b = QBrush(_state ? _light : _dark, SolidPattern);
  QPainter  p;
  
  p.begin(this);
  p.fillRect(_rect, b);
  p.end();
  
  QFrame::paintEvent(ev);
}


/*
 * Public methods
 *****************/
