/*  
 *  This file is part of kISDN, Copyright (C) 1998 by
 *
 *  Thorsten Westheider <twesthei@phya1.physik.uni-bielefeld.de>
 *  Carsten Pfeiffer <carpdjih@sp.zrz.tu-berlin.de>
 *
 ****************************************************************/
 
// $Id: rectled.h,v 1.2 1998/11/21 12:35:33 twesthei Exp $
//
// $Log: rectled.h,v $
// Revision 1.2  1998/11/21 12:35:33  twesthei
// Free edition is compiling and running at first glance; DoD
// seems to be broken, but it is also in the Professional Edition...
// I suppose, this has something to do with Kernel 2.0.36 (i.e.
// HiSax 3.1), since there seems to be a new ioctl for locking/
// unlocking DoD...gotta explore this matter.
//
// Revision 1.1.1.1  1998/11/21 10:18:58  twesthei
// Imported sources

 
#ifndef __RECTLED_H
#define __RECTLED_H

#include <qcolor.h>
#include <qframe.h>
#include <qrect.h>


class RectLED : public QFrame
{
  private:
  
    QColor  _light, _dark;
    QRect   _rect;
    bool    _state;
      
    void  paintEvent(QPaintEvent *); 
    
  public:
  
    RectLED(const QColor&, const QColor&, QWidget *parent = 0, const char *name = 0, 
            int w = 22, int h = 10);
    ~RectLED() {}
    
    void  setState(bool b) { _state = b; repaint(); }
    bool  isOn() const     { return _state;         }
};


#endif
