
// YAF include file
#include <devices/audioDevice.h>

#include <unistd.h>
#include <kmpgServer.h>
#include <ipc/ipcModule.h>
#include <kmpgCommandLine.h>


int main(int nargs,char** args) {
  // First we check if user want only help, before
  // we start the whole IPC stuff
  if (nargs >= 2) {
    if (strncmp(args[1],"-h",2) == 0) {
      KmpgCommandLine::usage();
      exit(0); 
    }
    if (strncmp(args[1],"--help",6) == 0) {
      KmpgCommandLine::usage();
      exit(0); 
    }

  }

  // Ok, no help wanted, start IPC and everything!
  // First we check if we are a client.
  IPCModule* ipcModule=new IPCModule("kmpg");
  if (ipcModule->isFirst() == false) {
    ipcModule->send(nargs,args);
    exit(0);
  }
  KApplication a( nargs, args, "kmpg" );
  // Ok we are the full application.
  cout << i18n ("Localisation not implemented") << endl;

  KmpgServer* kmpgServer=new KmpgServer();
  kmpgServer->newPlayer();
  KmpgCommandLine::parse(nargs,args);

  QObject::connect(ipcModule,SIGNAL(processCommandLine(CommandLineCreator*)),
		   kmpgServer,SLOT(processCommandLine(CommandLineCreator*)));
  a.exec();

  delete ipcModule;
  delete kmpgServer;

  return 0;
}



  



