/*
  root window for kmpg (menu and all this stuff)
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */




#ifndef __KMPGMAINWINDOW_H
#define __KMPGMAINWINDOW_H

// KDE include files
#include <kmenubar.h>
#include <ktmainwindow.h> 

// QT include files
#include <qpopmenu.h>
#include <qaccel.h>

// Player include files:
#include <kmpgPlayer.h>
#include <pathMapperConfig.h>
#include <kmpgCommandLine.h>

#include <playlistView2.h>
#include <id/playlistView3.h>
#include <playlistOperation.h>
#include <preferences.h>
#include <mixerConfig.h>
#include <ipc/ipcConfig.h>
#include <iostream.h>


class KmpgMainWindow : public KTMainWindow {
  Q_OBJECT
 public:
  KmpgMainWindow(QWidget *parent=0, const char *name=0);
  ~KmpgMainWindow();

  Playlist* getPlaylist();
  void addListener(NodeDevice* nodeDevice);
  void removeListener(NodeDevice* nodeDevice);
  GenericPlayer* getGenericPlayer();


 public slots:
  void openFileSelector();
  void onDrop(KDNDDropZone*);
  void closeSelected();

 signals:
  void closeEvent(KmpgMainWindow* kmpgMainWindow);
  void quitEvent();
  void newPlayerEvent();

 private:
  void buildMenuBar();

  KmpgPlayer* player;
  Playlist* playlist;
  KDNDDropZone* dropZone;
  PlaylistView2* playlistView2;
  Preferences* preferences;
  MixerConfig* mixerConfig;
  IPCConfig* ipcConfig;
  PathMapperConfig* pathMapperConfig;
  PlaylistView3* playlistView3;
};
#endif
