/*
  this class manages all instances of the players
  Copyright (C) 1999  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */




#ifndef __KMPGSERVER_H
#define __KMPGSERVER_H

#include <qobject.h>
#include <kmpgMainWindow.h>
#include <kmpgCommandLine.h>
#include <devices/mixerDevice.h>
#include <devices/audioDevice.h>
#include <deviceConfig/garbageCollector.h>


class KmpgServer : public QObject {
 Q_OBJECT

  MixerDevice* mixerDevice;
  AudioDevice* audioDevice;

 public:
   KmpgServer();
   ~KmpgServer();


 public slots:
   void newPlayer();
   void closePlayer(KmpgMainWindow* player);
   void processCommandLine(CommandLineCreator* cmdLine);
   void quit();

};
#endif
