
#include <qapp.h>
#include <amplifier/amplifier.h>
#include <devices/mixerDevice.h>
#include <devices/audioDevice.h>
#include <deviceConfig/garbageCollector.h>

#include <unistd.h>


/**
   This example starts two decoders adds a mixer and an
   audiodevice to it. 

   Make sure youe have edited the file

   ../SONGS.DEF


*/



#include "../SONGS.DEF"




int main(int nargs,char** args) {
  cout << "open file:"<<song[1]<<endl;
  cout << "open file:"<<song[2]<<endl;

  GarbageCollector::init();
  QApplication a( nargs, args);

  GenericPlayer* player1;
  GenericPlayer* player2;
  AudioDevice* audioDevice=new AudioDevice("/dev/dsp");
  MixerDevice* mixerDevice=new MixerDevice();

  player1=Amplifier::createPlayer(_MP3_DECODER);
  player2=Amplifier::createPlayer(_MP3_DECODER);


  player1->addListener(mixerDevice);
  player2->addListener(mixerDevice);
  
  mixerDevice->addListener(audioDevice);
  audioDevice->open();


  player1->open(song[1]);
  player2->open(song[2]);

  a.exec();

  delete player1;
  delete player2;
 
  return 0;
}



  
