#include <qapp.h>
#include <amplifier/amplifier.h>
#include <devices/genericPlayer.h>
#include <devices/audioDevice.h>
#include <deviceConfig/garbageCollector.h>

#include <guiControl.h>

#include <unistd.h>




/**
   This example adds a gui to a simple multimedia graph.
   For this it uses the basic widgetset.


   Make sure youe have edited the file

   ../SONGS.DEF


*/



#include "../SONGS.DEF"




int main(int nargs,char** args) {
  cout << "open file:"<<song[3]<<endl;
  GarbageCollector::init();

  QApplication a( nargs, args);

  GenericPlayer* player;
  AudioDevice* audioDevice=new AudioDevice("/dev/dsp");
  audioDevice->open();

  player=Amplifier::createPlayer(_MP3_DECODER);


  // First we build the multimedia graph:
  player->addListener(audioDevice);
  player->open(song[3]);

  // Then we start the guiControl for the player
  GuiControl* guiControl=new GuiControl();
  guiControl->attachTo(player);
  guiControl->buildGui();
  guiControl->show();
  
  // enter qt event loop
  a.exec();
  delete player;
  return 0;
}



  
