#include <amplifier/amplifier.h>
#include <devices/genericPlayer.h>
#include <devices/audioDevice.h>
#include <devices/multicastDevice.h>
#include <deviceConfig/garbageCollector.h>

#include "channelWidget.h"


#include <unistd.h>

#include <kapp.h>


/**
   This example show how to implement a new device.
   The device selects the left/right channel out of 
   the audiostream.
   (time consuming)

   Make sure youe have edited the file

   ../SONGS.DEF


*/



#include "../SONGS.DEF"




int main(int nargs,char** args) {
  cout << "open file:"<<song[2]<<endl;
  GarbageCollector::init();
  KApplication a( nargs, args);


  GenericPlayer* player;
  MulticastDevice* multicastDevice=new MulticastDevice();
  ChannelDevice* channelDevice=new ChannelDevice();
  AudioDevice* audioDevice=new AudioDevice("/dev/dsp");

  audioDevice->open();
  player=Amplifier::createPlayer(_MP3_DECODER);
  
  multicastDevice->addListener(channelDevice);
  multicastDevice->addListener(audioDevice);
  player->addListener(multicastDevice);


  ChannelWidget* channelWidget=new ChannelWidget();
  channelWidget->attachTo(channelDevice);
  channelWidget->show();

  player->open(song[2]);
  a.exec();
  delete player;
  return 0;
}



  
