/*
  mixes a DeviceConfigArray and delivers the result to the listeners
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */


#include <videoMixerDevice.h>



VideoMixerDevice::VideoMixerDevice() {
  VideoInfo* videoInfo;

  dest=new QPixmap();

  config=new DeviceConfig();

  videoInfo=config->getVideoInfo();
  videoInfo->setPixmap(dest);


  videoMixerFilter=new VideoMixerFilter();
}


VideoMixerDevice::~VideoMixerDevice() {
  delete dest;
  delete videoMixerFilter;
  delete config;
}


void VideoMixerDevice::writeOut(DeviceConfigArray* buf) {
  NodeDevice* nodeDevice;
  Edges* edges=getListeners();
  int n=edges->getElements();
  int i;
  
  videoMixerFilter->transform(buf,config);

  for(i=0;i<n;i++) {
    nodeDevice=edges->getNodeDevice(i);
    nodeDevice->writeInLock();
    nodeDevice->writeIn(this,config);
    nodeDevice->writeInUnlock();
  }
  

}


  
