/*
  a widget to add new players/channels 
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#include "videoMixerWidget.h"




VideoMixerWidget::VideoMixerWidget( QWidget *parent = 0,
				    const char *name = 0 ) :
  KTMainWindow( name ) {
  videoMixerDevice = new VideoMixerDevice();
  videoDevice=new VideoDevice();

  videoMixerDevice->addListener(videoDevice);


  guiVideoDevice = new GuiVideoDevice();
  guiVideoDevice->attachTo(videoDevice);
  guiVideoDevice->show();

  buildGui();
}


VideoMixerWidget::~VideoMixerWidget() {
}


void VideoMixerWidget::addChannel() {
  VideoPlayer* player;


  player=new VideoPlayer();
  player->addListener(videoMixerDevice);

  player->show();
}


void VideoMixerWidget::buildGui() {
  addChannelButton=new QPushButton( "add new Channel",this);
  addChannelButton->connect(addChannelButton,SIGNAL(clicked()),
			    this,SLOT(addChannel()) );

  setView(addChannelButton);
}


