/*
  creates/deletes MemChunks
  Copyright (C) 1999  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#ifndef __GARBAGECOLLECTOR_H
#define __GARBAGECOLLECTOR_H

#include <deviceConfig/memManager.h>
#include <pthread.h>
#include <iostream.h>

/**
   The garbageCollector creates MemChunk objects. If you
   delete MemChunk objects you <b>must</b> use for this
   the garbageCollector. He checks if someone
   holds a lock on the memChunk. If a lock is hold, he
   cannot delete the memory. He then checks if it is
   a shared memory. If yes he memcpy this memory
   and makes out of the memChunk a "standalone" memory
   object. This standalone memory object is then
   inserted in a "deleteIfNoLocks" list.
   
*/


class GarbageCollector {

 public:

  GarbageCollector();
  ~GarbageCollector();

  static void init();
  static MemChunk* createMemChunk(struct MemManager* memManager,int size);
  static int deleteMemChunk(MemChunk* memChunk);

  static void makeGarbageCollection();
  static int canMakeCollection();
};


#endif



