// 	$Id: eventwingeneral.h,v 1.19 1999/01/22 19:52:09 pbrown Exp $	

#ifndef _EVENTWINGENERAL_H
#define _EVENTWINGENERAL_H

#include <qframe.h>
#include <qlabel.h>
#include <qchkbox.h>
#include <qpushbt.h>
#include <qgrpbox.h>
#include <qlined.h>
#include <qcombo.h>
#include <qmlined.h>
#include <kapp.h>
#include <krestrictedline.h>

#include "ktimed.h"
#include "kdated.h"

class EditEventWin;

class EventWinGeneral : public QFrame
{
    Q_OBJECT

    friend EditEventWin;

public:

  EventWinGeneral(QWidget* parent = 0, const char* name = 0, bool todo = FALSE);
  virtual ~EventWinGeneral();

public slots:


protected slots:

  virtual void setEnabled(bool);
  void timeStuffDisable(bool disable);
  void alarmStuffEnable(bool enable);
  void alarmStuffDisable(bool disable);
  void pickAlarmSound();
  void pickAlarmProgram();

signals:
  void nullSignal(QWidget *);

protected:
  bool isTodo;
  void initMisc();
  void initTimeBox();
  void initAlarmBox();
  void initTodoSpecific();

  QGroupBox               *timeGroupBox;
  QLabel                  *summaryLabel;
  QLineEdit               *summaryEdit;
  QLabel                  *startLabel;
  QLabel                  *endLabel;
  KDateEdit               *startDateEdit;
  KDateEdit               *endDateEdit;
  KTimeEdit               *startTimeEdit;
  KTimeEdit               *endTimeEdit;
  QCheckBox               *noTimeButton;
  QCheckBox               *recursButton;
  QCheckBox               *alarmButton;
  KRestrictedLine         *alarmTimeEdit;
  QPushButton             *alarmSoundButton;
  QPushButton             *alarmProgramButton;
  QLabel                  *freeTimeLabel;
  QMultiLineEdit          *descriptionEdit;
  QComboBox               *freeTimeCombo;
  QLabel                  *ownerLabel;
  QCheckBox               *privateButton;
  QPushButton             *categoriesButton;
  QLabel                  *categoriesLabel;
  QComboBox               *alarmIncrCombo;

  // variables for the todo stuff
  QLabel                  *completedLabel;
  QCheckBox               *completedButton;
  QLabel                  *priorityLabel;
  QComboBox               *priorityCombo;
  QComboBox               *completedCombo;

  // variables to hold stuff temporarily.
  QString alarmSound;
  QString alarmProgram;
};

#endif
