/*
    $Id: ItemList.cpp,v 1.1 1998/09/23 12:04:05 dwerryh Exp $

    kTicker, a news headlines display program.
    
    Copyright (C) 1998 Paul Dwerryhouse   paul@xenu.ee.mu.oz.au

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "ItemList.h"

extern "C" {
#include <stdio.h>
#include <stdlib.h>
}

ItemList::ItemList() {
	item=0;
	num=0;
	curr=0;
}

ItemList::~ItemList() {
	if (!item) free(item);
}

int ItemList::add(TickerItem *i) {
	if (num==0) {
		if (!(item=(TickerItem **) malloc (sizeof(TickerItem *))))
			return 0;
		item[0]=i;
	} else {
		if (!(item=(TickerItem **) realloc (item,(num+1)*sizeof(TickerItem *))))
			return 0;
		item[num]=i;
	}
	num++;
	return 1;
}

TickerItem *ItemList::next() {
	TickerItem *x;

	if (!item) return 0;
	x=item[curr];
	curr++; 
	if (curr>num) {
		curr=0;
		return 0;
	}
	return x;
}
