/*
    $Id: NewsITN.cpp,v 1.3 1998/12/17 10:35:16 dwerryh Exp $

    kTicker, a news headlines display program.
    
    Copyright (C) 1998 Paul Dwerryhouse   paul@xenu.ee.mu.oz.au

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <kfm.h>
#include <kconfig.h>
#include <kurl.h>
#include <kapp.h>
#include <kmsgbox.h>
#include <kmenubar.h>
#include <ktopwidget.h>
#include <qobject.h>
#include <qwidget.h>
#include <qtimer.h>
#include <qpushbt.h>

#include "TickerItem.h"
#include "ItemList.h"
#include "NewsITN.h"
#include "NewsITN.moc"
#include "News.h"

extern "C" {
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "fgetline.h"
}

NewsITN::NewsITN() : News("ITN") {
}

void NewsITN::getNews() {
	char *t=tmpnam(0);

	if (!il) {
		delete il;
		il = new ItemList();
	}

	ready = 0;
	kfm=0;
	if (!(filename = (char *) malloc(sizeof(char) * (strlen(t) + 1)))) {
		fprintf(stderr,"Out of memory\n");
		exit(1);
	}
	strcpy(filename, t);

	kfm = new KFM;
	connect( kfm, SIGNAL( finished() ), this, SLOT( slotKFMJobDone() ) );
	kfm->copy(ITNURL, filename);
	ioDir = NewsITN::GET;
}

TickerItem* NewsITN::makeItem(char *line) {
	TickerItem *i = new TickerItem();

	i->setCategory(NULL);
	i->setRegion(NULL);
	i->setSource(NULL);
	i->setHeadline(line);
	i->setUrl("http://www.itn.co.uk/");

	return i;
}

void NewsITN::slotKFMJobDone() {
	FILE *fd;
	char *line;
	TickerItem *i;

	fd = fopen(filename,"r");
	while((line=fgetline(fd))) {
		i=makeItem(line);
		if (!il->add(i)) {
			fprintf(stderr,"Out of memory\n");
			exit(1);
		}				
	}
	fclose(fd);
	unlink(filename);

	ready=1;
}
