#include <kapp.h>

#include "OptBox.h"
#include "OptBox.moc"

OptBox::OptBox(KConfig *cfg,QWidget *parent, const char *name) : KConfigWidget( parent, name )
{
	int start;
	config = cfg;
        changetime=config->readNumEntry("changetime",3000);
	start=((changetime/1000-3)*2000/597);

	layout = new QVBoxLayout(this, 3);
	optionsbox = new QGroupBox(i18n("Options"),this);
	slider = new KSlider(0,2000,10,start,KSlider::Horizontal,optionsbox);
	slider->setSteps ( 125, 125 );
	slider->setTickmarks ( static_cast<QSlider::TickSetting>(QSlider::Below) );
	slider->setTickInterval ( 250 );
	slider->setTracking( true );

	slider_label = new QLabel(slider,i18n("Delay"),optionsbox);

	slider->adjustSize();
	slider_label->adjustSize();
	connect( slider, SIGNAL(sliderMoved(int)), SLOT(ChangeTime(int)));

	optionsbox->adjustSize();
	optionsbox->setMinimumSize(100, slider->sizeHint().height()+
			slider_label->sizeHint().height()+38);
	layout->addWidget(optionsbox, 3);

	buttonbox = new QFrame(this);
	hlayout = new QHBoxLayout(buttonbox, 3);

	ok = new QPushButton(buttonbox); ok->setText(i18n("OK"));
	hlayout->addWidget(ok, 3);
	connect( ok, SIGNAL(clicked()), SLOT(okclicked()) );

	apply = new QPushButton(buttonbox); apply->setText(i18n("Apply"));
	hlayout->addWidget(apply, 3);
	connect( apply, SIGNAL(clicked()), SLOT(applyclicked()) );

	cancel = new QPushButton(buttonbox); cancel->setText(i18n("Cancel"));
	hlayout->addWidget(cancel, 3);
	connect( cancel, SIGNAL(clicked()), SLOT(cancelclicked()) );

	layout->addWidget(buttonbox, 3);

	layout->activate();
	setGeometry(0,0,210,170);
};

/*
void main(int argc,char **argv) {
	int retval;
	KApplication *mykapp;
	mykapp = new KApplication(argc, argv, "ktest");	
	OptBox *ob = new OptBox(NULL,"test");
	mykapp->setMainWidget(ob);
	ob->setMinimumSize(50,50);
	ob->show();
	retval = mykapp->exec();
	return retval;
}
*/

void OptBox::loadSettings() {};
void OptBox::applySettings() {};

void OptBox::resizeEvent(QResizeEvent *e) {
	KConfigWidget::resizeEvent(e);

	slider_label->adjustSize();
	slider->move(30,30);
	slider_label->move(30+slider->width()+5,30);
}

void OptBox::ChangeTime(int value)
{
	int t;
	t=1000*((value*597)/2000 + 3);
	changetime=t;
}

void OptBox::okclicked() {
        config->writeEntry("changetime",changetime);
        emit(changedopts(config));
        close();
}			

void OptBox::applyclicked() {
        config->writeEntry("changetime",changetime);
        emit(changedopts(config));
}
