#ifndef OPTBOX_H
#define OPTBOX_H

#include <kconfig.h>
#include <kwizard.h>
#include <kslider.h>
#include <qlabel.h>
#include <qrect.h>
#include <qgroupbox.h>
#include <qpushbt.h>
#include <qlayout.h>
#include <kcontrol.h>

class OptBox : public KConfigWidget
{
  Q_OBJECT

  public:

  OptBox(KConfig *,QWidget *,const char *);
  virtual void loadSettings();
  virtual void applySettings();

  public slots:

  void okclicked ();
  void applyclicked ();
  void cancelclicked () { close(); }

  protected slots:

  virtual void ChangeTime (int);   

  protected:

  void resizeEvent(QResizeEvent *);
  KSlider *slider;
  QLabel *slider_label;
  QGroupBox *optionsbox;
  QFrame *buttonbox;
  QHBoxLayout *hlayout;
  QVBoxLayout *layout;
  QPushButton *ok,*cancel,*apply;
  KConfig *config;
  int changetime;

  signals:

  void changedopts (KConfig *cfg);

};

#endif /* OPTBOX_H */
