/**********************************************************************

	--- Qt Architect generated file ---

	File: TickWidget.h
	Last generated: Wed Aug 5 13:56:23 1998

 *********************************************************************/

#ifndef TickWidget_included
#define TickWidget_included

#include "TickWidgetData.h"

class TickWidget : public TickWidgetData
{
    Q_OBJECT

public:

    TickWidget
    (
        QWidget* parent = NULL,
        const char* name = NULL
    );

    virtual ~TickWidget();

    void setFGCol(QColor col) {
	    fgcol=col;
    }
    void setHiFGCol(QColor col) {
	    hifgcol=col;
    }

    void setBGCol(QColor col) {
	    bgcol=col;
    }
    void setHiBGCol(QColor col) {
	    hibgcol=col;
    }

    void setColour(int i) {
	    high=i;
	    if (i) { 
		    label->setBackgroundColor(hibgcol);
		    label->setTextColour(hifgcol,hibgcol);
	    } else {
		    label->setBackgroundColor(bgcol);
		    label->setTextColour(fgcol,bgcol);
	    }
    }
    void resetColour() {
	    setColour(high);
    }	    

    void setHiColour() {
	    setColour(1);
    }
    void setLoColour() {
	    setColour(0);
    }
    void setText(const char *s) { 
    	label->setText(s); 
	label->setAlignment(AlignVCenter);
    }

    void setStopped() {
    	play->setEnabled(1);
	stop->setEnabled(0);
	stepforward->setEnabled(1);
	stepback->setEnabled(1);
    }

    void setPlay() {
    	play->setEnabled(0);
	stepforward->setEnabled(0);
	stepback->setEnabled(0);
	stop->setEnabled(1);
    }

signals:
        void clicked(QMouseEvent *me);
        void stopTicker();
        void startTicker();
        void fwdTicker();
        void rvsTicker();

public slots:
	void slotClicked(QMouseEvent *me) { emit clicked(me); }
	void slotStop() { emit stopTicker(); }
	void slotPlay() { emit startTicker(); }
	void slotFwd() { emit fwdTicker(); }
	void slotRvs() { emit rvsTicker(); }

private:
	QColor fgcol;
	QColor hifgcol;
	QColor bgcol;
	QColor hibgcol;
	int high;
};
#endif // TickWidget_included
