/*
    $Id: kticker.h,v 1.11 1999/02/13 03:21:24 dwerryh Exp $

    kTicker, a news headlines display program.
    
    Copyright (C) 1998 Paul Dwerryhouse   paul@xenu.ee.mu.oz.au

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef KTICKER_H
#define KTICKER_H


// Comment this out if you want to see the www.7am.com news instead of the BBC
#define BBC

#include <kurl.h>
#include <kapp.h>
#include <kmsgbox.h>
#include <kmenubar.h>
#include <ktopwidget.h>
#include <kcontainer.h>  
#include <qwidget.h>
#include <qtimer.h>
#include <qpushbt.h>
#include <qpopmenu.h>
#include "NewsSevenAM.h"
#include "NewsBBC.h"
#include "NewsSlashDot.h"
#include "NewsITN.h"
#include "NewsCEO.h"
#include "ItemList.h"
#include "TickerItem.h"
#include "OptBox.h"
#include "TickWidget.h"

typedef struct _item {

	char *headline;
	char *url;
	int story;
	struct _item *next;
} item;

class KTicker : public QWidget {
	Q_OBJECT
public:
	char *filename;
	enum transferDirection {GET, PUT};
	void setText(char *);
	void loadData(char *);
	KTicker();
public slots:
	void slotClickLink(QMouseEvent *);
	void slotTimeSignal();
	void slotOpenLink();
	void slotStopTicker();
	void slotStartTicker();
	void slotFwdItem();
	void slotRvsItem();
	void slotChangeOpts(KConfig *);
	void configOptions();
	void getHelp();
	void aboutDlg();
	void saveOptions();
	void restartBBC();
	void restartSevenAM();
	void restartSlashDot();
	void restartFreshmeat();
	void restartITN();
	void restartCEO();
	void quitApp();
protected:
	void enterEvent(QEvent *qe);
	void leaveEvent(QEvent *qe);
        void setCheckedFeed(int id);
	void setSiteCaption();
private:
	transferDirection ioDir;
	KFM *kfm;
	QTimer *timer;
	int havedata;
	item *headlines;
	item *current;
	News *news;
	ItemList *il;
	TickerItem *currentItem;
	QPopupMenu *popmenu;
        QPopupMenu *feedpopmenu;
	OptBox *kttest;
	TickWidget *tw;
	KMsgBox *about;
};


#endif
