/*
    KTop, a taskmanager and cpu load monitor
   
    Copyright (C) 1997 Bernd Johannes Wuebben
                       wuebben@math.cornell.edu

    Copyright (C) 1998 Nicolas Leclercq
                       nicknet@planete.net
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef _memory_h_
#define _memory_h_

#include <qwidget.h>
#include <qbrush.h>

#include "OSStatus.h"

/*=============================================================================
  CLASSes
 =============================================================================*/
//-----------------------------------------------------------------------------
// class  : MemMon
//-----------------------------------------------------------------------------
class MemMon : public QWidget
{
    Q_OBJECT

public:     
     MemMon (QWidget *parent = 0, const char *name = 0, QWidget *child = 0);
    ~MemMon ();

protected:

    virtual void paintEvent(QPaintEvent *);
    virtual void timerEvent(QTimerEvent *);

private:
	OSStatus os;

    int      intervals,
             mem_size, 
             physsize,
            *mem_values;
    QWidget *my_child;
    QBrush   brush_0, 
             brush_1;
};

//-----------------------------------------------------------------------------
// class  : SwapMon
//-----------------------------------------------------------------------------
class SwapMon : public QWidget
{
  Q_OBJECT

public:

   SwapMon (QWidget *parent = 0, const char *name = 0, QWidget *child = 0);
  ~SwapMon ();

protected:

  virtual void paintEvent(QPaintEvent *);
  virtual void timerEvent(QTimerEvent *);

private:
	OSStatus os;

  QWidget  *my_child;
  int       swapVals[3],
            tid;
  char     *memZone;
  unsigned *swapData,
            indx,
            ticks;
  QBrush    brush_0, 
            brush_1, 
            brush_2;
};

#endif
