//   $Id: kvi_mlined.h,v 1.3 1998/09/28 13:05:20 pragma Exp $
//
//   This file is part of the KVIrc+ irc client distribution
//   Copyright (C) 1998 Szymon Stefanek (stefanek@tin.it)
//
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU General Public
//   License as published by the Free Software Foundation; either
//   version 2 of the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//   Library General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this library; see the file COPYING.LIB.  If not, write to
//   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//   Boston, MA 02111-1307, USA.
//
#ifndef _KVI_MLINED_H_INCLUDED_
#define _KVI_MLINED_H_INCLUDED_

#include <qmultilinedit.h>
#include <qwidget.h>

class KviClrBox;
class KviFrame;
class KviInterface;

class KviMultiLineEdit : public QMultiLineEdit{
	Q_OBJECT
public:
	KviMultiLineEdit(QWidget *parent,KviFrame *lpFrame);
	~KviMultiLineEdit();
public:
	KviInterface *m_lpInt;
//	QColor m_backColor;
//	QColor m_foreColor;
//	QColor m_cursorColor;
//
//	QColor m_commentColor;
//	QColor m_commandColor;
//	QColor m_variableColor;
//	QColor m_braceColor;
//	QColor m_operatorColor;
//	QColor m_chanColor;
	bool   m_bNewCmd;
	KviFrame *m_lpFrm;
	KviClrBox *m_lpColorBox;

protected:
	virtual void paintCell(QPainter *pnt, int row, int coll);
	virtual void keyPressEvent(QKeyEvent *e);
	void newExtractNextWord(QString &szText,QString &szWord);
	QColor * newGetColor(QString &szData);
	void extractNextWord(QString &szText,QString &szWord);
	QColor * getColor(QString &szData);
};

#endif //_KVI_MLINED_H_INCLUDED_
