//
//   File : kvi_qhelp.h (/usr/cvs/kvirc/kvirc/kvi_qhelp.h)
//   Last modified : Tue Dec 1 1998 16:48:03 by root@localhost.localdomain
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1998-1999 Szymon Stefanek (stefanek@tin.it)
//
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation ; either
//   version 2 of the License, or (at your option) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; see the file COPYING. If not, write to
//   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//   Boston, MA 02111-1307, USA.
//

#include <qstring.h>
#include <qwidget.h>
#include <kquickhelp.h>

//
// Options dialog
//

#define KVI_QH_DLG_OPTIONS 1

#define KVI_QH_RES_CAPTION_LINED 1
#define KVI_QH_RES_QUIT_LINED 2
#define KVI_QH_RES_PART_LINED 3
#define KVI_QH_RES_KICK_LINED 4
#define KVI_QH_RES_AWAY_LINED 5
#define KVI_QH_RES_FINGER_LINED 6
#define KVI_QH_RES_USERINFO_LINED 7
#define KVI_QH_RES_SCRIPT_LINED 8
#define KVI_QH_RES_STATUS_LINED 9

#define KVI_QH_RES_IGNORECHAT_CHK 21
#define KVI_QH_RES_AUTOCHAT_CHK 22
#define KVI_QH_RES_IGNORESEND_CHK 23
#define KVI_QH_RES_AUTOSEND_CHK 24
#define KVI_QH_RES_IGNOREVOICE_CHK 25
#define KVI_QH_RES_AUTOVOICE_CHK 26
#define KVI_QH_RES_CLOSESEND_CHK 27
#define KVI_QH_RES_MINIMIZESEND_CHK 28
#define KVI_QH_RES_CHATTIMEOUT_LINED 30
#define KVI_QH_RES_SENDPACKET_COMBO 31
#define KVI_QH_RES_FASTSENDPACKETS_COMBO 32
#define KVI_QH_RES_USEFASTSEND_CHK 33

#define KVI_QH_RES_MOTDIN_CHK 40
#define KVI_QH_RES_MOTDOUT_CHK 41
#define KVI_QH_RES_MOTD_MLINED 42

#define KVI_QH_RES_DCCDAEMON_CHK 50
#define KVI_QH_RES_DCCDAEMONPORT_LINED 51
#define KVI_QH_RES_DCCDAEMONCHAT_CHK 52
#define KVI_QH_RES_DCCDAEMONSEND_CHK 53
#define KVI_QH_RES_DCCDLOGINTIMEOUT_LINED 54

#define KVI_QH_RES_MASSDEOPTIME_LINED 60
#define KVI_QH_RES_MASSDEOPDEADLINE_LINED 61
#define KVI_QH_RES_MASSOPTIME_LINED 62
#define KVI_QH_RES_MASSOPDEADLINE_LINED 63
#define KVI_QH_RES_MASSKICKTIME_LINED 64
#define KVI_QH_RES_MASSKICKDEADLINE_LINED 65
#define KVI_QH_RES_MASSBANTIME_LINED 66
#define KVI_QH_RES_MASSBANDEADLINE_LINED 67
#define KVI_QH_RES_PUBLICFLOODTIME_LINED 68
#define KVI_QH_RES_PUBLICFLOODDEADLINE_LINED 69
#define KVI_QH_RES_MAXCTCP_LINED 70
#define KVI_QH_RES_TIMERCTCP_LINED 71

#define KVI_QH_RES_USETRANSLATION_CHK 80
#define KVI_QH_RES_DONOTTRANSLATEDCC_CHK 81

#define KVI_QH_RES_TEXTUSERBUF_LINED 90
#define KVI_QH_RES_IDENTPARSINGOFF_CHK 91
#define KVI_QH_RES_AUTONICKCOMPLETION_CHK 92
#define KVI_QH_RES_POPUPCTRLK_CHK 93
#define KVI_QH_RES_CMDPREFIX_LINED 94

#define KVI_QH_RES_UNDEFINED 95

//
// Server settings dialog
//

#define KVI_QH_DLG_SERVER 2

#define KVI_QH_RES_NETWORK_COMBO 1
#define KVI_QH_RES_REMOVENET_BUTTON 2
#define KVI_QH_RES_SERVER_LIST 3
#define KVI_QH_RES_READFROMINI_BUTTON 4
#define KVI_QH_RES_CACHELOOKUPS_CHECK 5
#define KVI_QH_RES_TIMEOUT_LINED 6
#define KVI_QH_RES_RECONNONFAIL_CHECK 7
#define KVI_QH_RES_RECONNONDISC_CHECK 8
#define KVI_QH_RES_USEPROXY_CHECK 9
#define KVI_QH_RES_PROXY_LIST 10
#define KVI_QH_RES_SOCKSV5_CHECK 11
#define KVI_QH_RES_MOVETOTOP_BUTTON 12
#define KVI_QH_RES_MOVEUP_BUTTON 13
#define KVI_QH_RES_MOVEDOWN_BUTTON 14
#define KVI_QH_RES_ADDSERVER_BUTTON 15
#define KVI_QH_RES_REMOVESERVER_BUTTON 16
#define KVI_QH_RES_EDITSERVER_BUTTON 17
#define KVI_QH_RES_SORTSERVER_BUTTON 18
#define KVI_QH_RES_ADDPROXY_BUTTON 19
#define KVI_QH_RES_REMOVEPROXY_BUTTON 20
#define KVI_QH_RES_EDITPROXY_BUTTON 21

//
// User settings dialog
//

#define KVI_QH_DLG_USER 3

#define KVI_QH_RES_NICK_LINED 1
#define KVI_QH_RES_ALTNICK_LINED 2
#define KVI_QH_RES_USERNAME_LINED 3
#define KVI_QH_RES_REALNAME_LINED 4
#define KVI_QH_RES_WALLOPS_CHECK 5
#define KVI_QH_RES_INVISIBLE_CHECK 6
#define KVI_QH_RES_SERVERNOTICES_CHECK 7

void addKviQuickHelp(QWidget *widget,int idDialog,int idResource);


