#!/usr/bin/perl -w

# kweblinuxtoday.pl v1.3 beta written by Carmelo Piccione
# who fiddled with wmlinuxtoday.pl v1.1, written by Jeff Meininger
# You can reach me here:
# 	web: http://members.xoom.com/cpiccione/
# 	email: clasp@cyberzone.net
# You can reach Jeff here:
# 	web: 	http://rive.boxybutgood.com/WMHeadlines/ -
# 	email: jeffm@boxybutgood.com
#
# Original concept by Pascal Hofstee...
#    <daeron@shadowmere.student.utwente.nl>
#
# Proxy support based on code provided by Dan Gundlach...
#    <dan@msl.net>
#
# (k)weblinuxtoday is licensed under the GPL version 2.
# wmlinuxtoday is Copyright (C) 1999 by Jeff Meininger
#
# For setup information, please see the following URL...
# http://www.geocities.com/ResearchTriangle/System/8474/
#
# For configuration options, type 'kweblinuxtoday.pl --help'
#    All options are available from the command line.
#
# NO NEED TO EDIT THIS FILE FOR CONFIGURATION PURPOSES!

require 5.002;
use strict;
use Socket;


my $sitename = "LinuxToday";
my $scriptname = "linuxtoday";
my $remote = 'linuxtoday.com';
my $url = "/lthead.txt";
my @time = localtime();
my $kick = "\n\n"; ## This is outright stolen from WMHeadlines 1.3
my $newicon = 0;
my $badchar = 0;
my ($iaddr, $paddr, $proto, $line, $menufile, $tmpfile, $proxy);
my $isdirempty = "";
my $datetest;
my ($twentyfour, $dayfirst, $proxyflag, $loudflag, $flushflag) = (0)x5;
my ($showdate) = (1)x1;

my ($frontpage, $deathtext, $datestring, $basedir, $headdir) = ("")x5;
my ($iconnew, $iconold) = ("")x2;
my $cleanup = 3;
my $maxlength = 0;
my $port = 80;
my $ampmstring = "AM";
my $yearstring = "-" . ($time[5] + 1900);

# get configuration from commandline
my $i;
for ($i = 0; $i < scalar(@ARGV); $i++) {
	if ($ARGV[$i] eq "--help") {
		print "\nkweb$scriptname.pl usage:\n";
		print "[-headdir directory] - specifies headline directory.\n";
		print "[-basedir directory] - specifies base directory (usually where kdisknav is).\n";
		print "[-cleanup hours] - remove old headlines when they are X hours old (default = 3).\n";
		print "[-iconnew ] - mini icon for new headlines (default=wwwnew.xpm).\n";
		print "[-iconold ] - mini icon for old headlines (default=www.xpm).\n";
		print "[-maxlength length] - maximum length of headline name (default = none)\n";
		print "[-proxy host port] - enables use over a proxy.\n";
		print "[-proxyfix ] - this may fix some problems with picky proxies.\n";
		print "[-frontpage on/off] - enables/disables an item for the $sitename frontpage.\n";
		print "[-loud] - useful for debugging problems. Otherwise, the script exits quietly\n\tin the case of an error.\n";
		print "[-24] - display time in 24 format instead of 12 AM/PM\n";
		print "[-dayfirst] - display day before month (like 25-12-1999) in date.\n";
		print "[-nodate] - do not display 'last updated' date in menu title.\n";
		print "[-noyear] - do not display the year in the 'last updated' date.\n";
		print "[-flush] - remove (forceful) all old headlines";
		print "\n";
		exit();
	} elsif($ARGV[$i] eq "-headdir") {
		if ((!defined($ARGV[$i + 1])) || ($ARGV[$i + 1] =~ /^-/)) {
			print "Please use '-headdir destination_directory' - this is where the .kdelnk files will be created.\n";
			exit();
		} else {
			$headdir = $ARGV[$i + 1];
		}

	} elsif($ARGV[$i] eq "-basedir") {
		if ((!defined($ARGV[$i + 1])) || ($ARGV[$i + 1] =~ /^-/)) {
			print "Please use '-basedir destination_directory' - this is usually ~/.kde/share/apps/kdisknav/\n";
			exit();
		} else {
			$basedir = $ARGV[$i + 1];
		}

	} elsif($ARGV[$i] eq "-cleanup") {
		if ((!defined($ARGV[$i + 1])) || ($ARGV[$i + 1] =~ /\D/)) {
			print "This option specifies how long to keep headlines in hours- Use a numerical value";
			exit();
		} else {
			$cleanup = $ARGV[$i + 1];
		}

	} elsif($ARGV[$i] eq "-iconnew") {
		if ((!defined($ARGV[$i + 1])) || ($ARGV[$i + 1] =~ /^-/)) {
			print "Pick an xpm file that is in your kde share directory";
			exit();
		} else {
			$iconnew = $ARGV[$i + 1];
		}

	} elsif($ARGV[$i] eq "-iconold") {
		if ((!defined($ARGV[$i + 1])) || ($ARGV[$i + 1] =~ /^-/)) {
			print "Pick an xpm file that is in your kde share directory";
			exit();
		} else {
			$iconold = $ARGV[$i + 1];
		}


	} elsif($ARGV[$i] eq "-maxlength") {
		if ((!defined($ARGV[$i + 1])) || ($ARGV[$i + 1] =~ /\D/)) {
			print "This option specifies the maximum length of the headline. Use a numerical value";
			exit();
		} else {
			$maxlength = $ARGV[$i + 1];
		}


	} elsif($ARGV[$i] eq "-proxy") {
		if ((!defined($ARGV[$i + 2])) || ($ARGV[$i + 1] =~ /^-/) || ($ARGV[$i + 2] =~ /^-/) || ($ARGV[$i + 2] =~ /\D/)) {
			print "Please use '-proxy proxy.yourisp.com 3128' or whatever is appropriate.\n";
			exit();
		} else {
			$proxyflag = 1;
			$proxy = $ARGV[$i + 1];
			$port = $ARGV[$i + 2];
		}

        } elsif($ARGV[$i] eq "-proxyfix") {
		$kick = "\r\n\r\n";

	} elsif($ARGV[$i] eq "-frontpage") {
		if ((!defined($ARGV[$i + 1])) || (($ARGV[$i + 1] ne "on") && ($ARGV[$i + 1] ne "off"))) {
			print "Please use '-frontpage on' or '-frontpage off' to enable/disable this feature.\n";
			exit();
		} else {
			$frontpage = $ARGV[$i + 1];
		}
	} elsif($ARGV[$i] eq "-loud") {
		$deathtext = "ERROR: could not connect to remote site";
	} elsif($ARGV[$i] eq "-24") {
		$twentyfour = 1;
	} elsif($ARGV[$i] eq "-dayfirst") {
		$dayfirst = 1;
	} elsif($ARGV[$i] eq "-nodate") {
		$showdate = 0;
	} elsif($ARGV[$i] eq "-noyear") {
		$yearstring = "";
	} elsif($ARGV[$i] eq "-flush") {
		$flushflag = 1;
	}
	
}


if ($twentyfour > 0) {
	$ampmstring = "";
} else {
	if ($time[2] > 11) {
		$ampmstring = "PM";
	}
	
	if ($time[2] > 12) {
		$time[2] = $time[2] - 12;
	}
}

if ($showdate > 0) {
	if ($dayfirst > 0) {
		$datestring = " [$time[3]-" . ($time[4] + 1) . "$yearstring, " . $time[2] . ":" . sprintf("%02d", $time[1]) . "$ampmstring]";
	} else {
		$datestring = " [" . ($time[4] + 1) . "-$time[3]$yearstring, " . $time[2] . ":" . sprintf("%02d", $time[1]) . "$ampmstring]";
	}
} else {
	$datestring = "";
}

# If no directory specificed use default (this was changed from v1.1)
if ($basedir eq "") {$basedir = "$ENV{HOME}/.kde/share/apps/kdisknav";}
if ($headdir eq "") {$headdir = "LinuxToday"; }
if ($iconnew eq "") {$iconnew = "wwwnew.xpm"; }
if ($iconold eq "") {$iconold = "www.xpm"; }

# ...maybe Ill make a separate parser script next release.
# Let me know what you think
## Alright I think this section is functional...
if ($flushflag == 1) {

$isdirempty = `ls $basedir/$headdir/`;
	if ($isdirempty ne "") {
		# Goodbye old news
		system("rm $basedir/$headdir/*");
		}

} else {

opendir(TMPDIR, "$basedir/$headdir"); 			 	 	
my $j = 0;
	for (readdir(TMPDIR)) {
	$j++;
		if ($j > 3) {
		$datetest = "$_";
		if (index($datetest, $sitename) > -1) {
			system("rm $basedir/$headdir/\"$datetest\"");
						}

		if ((-e "$basedir/$headdir/$datetest") && (-M "$basedir/$headdir/$datetest" > $cleanup/24))
			{ system("rm $basedir/$headdir/\"$datetest\""); }
	 	}
	}
}
closedir(TMPDIR);
### End of cleanup section


# This code puts a link to the main page in the headline menu
# It also shows the date of head line retrieval.
if ($frontpage eq "on") {
	$menufile = "$basedir/$headdir/$sitename-$datestring.kdelnk";
	open(TMPFILE, ">$menufile"); 			 	 	
	print TMPFILE "# KDE Config File\n"; 			 	
	print TMPFILE "[KDE Desktop Entry]\n";
	print TMPFILE "URL=http://$remote/\n";  	
	print TMPFILE "Icon=www.xpm\n";
	print TMPFILE "MiniIcon=www.xpm\n";
	print TMPFILE "Type=Link\n";
	close(TMPFILE);
}

# network connection portion is pretty much stolen from 'man perlipc'
if ($proxyflag > 0) {
	$iaddr = inet_aton($proxy) || wmdie($deathtext);
} else {
	$iaddr = inet_aton($remote) || wmdie($deathtext);
}
$paddr = sockaddr_in($port, $iaddr);
$proto = getprotobyname('tcp');
socket(SOCK, PF_INET, SOCK_STREAM, $proto) || wmdie($deathtext);
connect(SOCK, $paddr) || wmdie($deathtext);

select(SOCK); $| = 1; select(STDOUT);

if ($proxyflag > 0) {
	print SOCK "GET http://$remote$url HTTP/1.1$kick";
} else {
	print SOCK "GET $url HTTP/1.1\nHost: $remote:80$kick";
}


$i = 0;
my $flag = 0;

while (defined($line = <SOCK>)) {
	$i++;
	
	if ($line =~ /^&&/) { $i = 1; $flag = 1; }
	
	if ($flag > 0) {
		if ($i == 2) {
			chop($line);
			$line =~ s/"/'/g;
			$line =~ s/<.*?>//g;
			$badchar = (index $line, "/");
	if (length($line) > $maxlength) {
		$line = substr($line, 0, $maxlength) . "...";   }

	# This checks if there is a "/" in the string. That is a no no.
	if ($badchar > -1) {
		     $line = (substr($line, 0, $badchar));
		     $line = "$line..."; }
	$menufile = "$basedir/$headdir/$line.kdelnk";
	if (-e $menufile) { $newicon = 0 } else { $newicon = 1 };
	open(TMPFILE, ">$menufile"); 			 	
	print TMPFILE "# KDE Config File\n"; 			 	
	print TMPFILE "[KDE Desktop Entry]\n";
	print TMPFILE "URL=";
		} elsif ($i == 3) { 			
		chop($line);
		print TMPFILE "$line\n";
		print TMPFILE "Icon=www.xpm\n";
			# New headline = new icon
			if ($newicon == 1) {
				print TMPFILE "MiniIcon=$iconnew\n";
			} else {
				print TMPFILE "MiniIcon=$iconold\n";				
			}
		print TMPFILE "Type=Link\n";
		close(TMPFILE);
		} 	
	}
}

close(SOCK) || die "Error closing socket: $!";
close(TMPFILE);
exit();

sub wmdie {
	my $string = shift;
	if ($string ne "") {
		print "$string\n";
	}
	
	close(SOCK);
	close(TMPFILE);
	
	exit(1);
}