#!/usr/bin/perl -w

# kwmslashdot.pl v1.0 written by Carmelo Piccione
# who fiddled with wmslashdot.pl v1.1, written by Jeff Meininger
# You can reach me here:
# 	web: http://www.geocities.com/ResearchTriangle/System/8474/
# 	email: clasp@cyberzone.net
# You can reach Jeff here:
# 	web: 	http://rive.boxybutgood.com/WMHeadlines/ -
# 	email: jeffm@boxybutgood.com
#
# Original concept by Pascal Hofstee...
#    <daeron@shadowmere.student.utwente.nl>
#
# Proxy support based on code provided by Dan Gundlach...
#    <dan@msl.net>
#
# (k)wmslashdot is licensed under the GPL version 2.
# wmslashdot is Copyright (C) 1999 by Jeff Meininger
#
# For setup information, please see the following URL...
# http://www.geocities.com/ResearchTriangle/System/8474/
#
# For configuration options, type 'kwmslashdot.pl --help'
#    All options are available from the command line.
#
# NO NEED TO EDIT THIS FILE FOR CONFIGURATION PURPOSES!

require 5.002;
use strict;
use Socket;


my $sitename = "Slashdot";
my $scriptname = "slashdot";
my $remote = 'localhost';
my $url = "/backend.txt";
# Added this for kde disk navigation directory
my $isdirempty = "";
my @time = localtime();
my $line = "";
my @format;
my ($iaddr, $paddr, $proto, $menufile, $tmpfile, $proxy);

my ($twentyfour, $dayfirst, $proxyflag, $loudflag) = (0)x4;
my ($showdate, $newflag) = (1)x2;
my $headerdir = "Slashdot";
my ($frontpage, $deathtext, $datestring) = ("")x3;
my $badchar = 0;
my $port = 80;
my $ampmstring = "AM";
my $yearstring = "-" . ($time[5] + 1900);

# get configuration from commandline
my $i;
for ($i = 0; $i < scalar(@ARGV); $i++) {
	if ($ARGV[$i] eq "--help") {
		print "\nwm$scriptname.pl usage:\n";
		print "[-proxy host port] - enables use over a proxy\n";
		print "[-frontpage on - enables/disables a persistant item for the $sitename frontpage.\n";
		print "[-loud] - useful for debugging problems. Otherwise, the script exits quietly\n\tin the case of an error.\n";
		print "[-24] - display time in 24 format instead of 12 AM/PM\n";
		print "[-dayfirst] - display day before month (like 25-12-1999) in date.\n";
		print "[-nodate] - do not display 'last updated' date in menu title.\n";
		print "[-noyear] - do not display the year in the 'last updated' date.\n";
		print "\n";
		exit();
	} elsif($ARGV[$i] eq "-proxy") {
		if ((!defined($ARGV[$i + 2])) || ($ARGV[$i + 1] =~ /^-/) || ($ARGV[$i + 2] =~ /^-/) || ($ARGV[$i + 2] =~ /\D/)) {
			print "Please use '-proxy proxy.yourisp.com 3128' or whatever is appropriate.\n";
			exit();
		} else {
			$proxyflag = 1;
			$proxy = $ARGV[$i + 1];
			$port = $ARGV[$i + 2];
		}
	} elsif($ARGV[$i] eq "-frontpage") {
		if ((!defined($ARGV[$i + 1])) || (($ARGV[$i + 1] ne "on") && ($ARGV[$i + 1] ne "off"))) {
			print "Please use '-frontpage on' or '-frontpage off' to enable/disable this feature.\n";
			exit();
		} else {
			$frontpage = $ARGV[$i + 1];
		}
	} elsif($ARGV[$i] eq "-loud") {
		$deathtext = "ERROR: could not connect to remote site";
	} elsif($ARGV[$i] eq "-24") {
		$twentyfour = 1;
	} elsif($ARGV[$i] eq "-dayfirst") {
		$dayfirst = 1;
	} elsif($ARGV[$i] eq "-nodate") {
		$showdate = 0;
	} elsif($ARGV[$i] eq "-noyear") {
		$yearstring = "";
	}
	
}


if ($twentyfour > 0) {
	$ampmstring = "";
} else {
	if ($time[2] > 11) {
		$ampmstring = "PM";
	}
	
	if ($time[2] > 12) {
		$time[2] = $time[2] - 12;
	}
}

if ($showdate > 0) {
	if ($dayfirst > 0) {
		$datestring = " [$time[3]-" . ($time[4] + 1) . "$yearstring, " . $time[2] . ":" . sprintf("%02d", $time[1]) . "$ampmstring]";
	} else {
		$datestring = " [" . ($time[4] + 1) . "-$time[3]$yearstring, " . $time[2] . ":" . sprintf("%02d", $time[1]) . "$ampmstring]";
	}
} else {
	$datestring = "";
}

# Lets clear the $headerdir directory first
# Scan's your kdisknav directory for any links
$isdirempty = `ls $ENV{HOME}/.kde/share/apps/kdisknav/$headerdir/`;
# If it is not empty, it removes all files
if ($isdirempty ne "")
{
# Goodbye old news
system("rm $ENV{HOME}/.kde/share/apps/kdisknav/$headerdir/*");
}

# -- Perhaps put Link to website here? Put Date and Time in link name? Hey, why not??
if ($frontpage eq "on") {
	$menufile = "$ENV{'HOME'}/.kde/share/apps/kdisknav/$headerdir/$remote-$datestring.kdelnk";
	open(TMPFILE, ">$menufile"); 			 	 	
	print TMPFILE "# KDE Config File\n"; 			 	
	print TMPFILE "[KDE Desktop Entry]\n";
	print TMPFILE "URL=http://$remote/\n";  	
	print TMPFILE "Icon=www.xpm\n";
	print TMPFILE "MiniIcon=www.xpm\n";
	print TMPFILE "Type=Link\n";
	close(TMPFILE);
}

# network connection portion is pretty much stolen from 'man perlipc'
if ($proxyflag > 0) {
	$iaddr = inet_aton($proxy) || wmdie($deathtext);
} else {
	$iaddr = inet_aton($remote) || wmdie($deathtext);
}
$paddr = sockaddr_in($port, $iaddr);
$proto = getprotobyname('tcp');
socket(SOCK, PF_INET, SOCK_STREAM, $proto) || wmdie($deathtext);
connect(SOCK, $paddr) || wmdie($deathtext);

select(SOCK); $| = 1; select(STDOUT);

if ($proxyflag > 0) {
	print SOCK "GET http://$remote$url HTTP/1.0\n\n";
} else {
	print SOCK "GET $url\n\n";
}


$i = 0;
my $flag = 0;
while (defined($line = <SOCK>)) {
	$i++;
	
	if ($line =~ /^%%/) { $i = 1; $flag = 1; }
	
	if ($flag > 0) {
		if ($i == 2) {
			chop($line);
			$line =~ s/"/'/g;
			$line =~ s/<.*?>//g;
			$line =~ s/.*.html//g;
			$badchar = (index $line, "/");
	if ($badchar > -1) {
		     $line = (substr($line, 0, $badchar));
		     $line = "$line...";
	}
# KDE implementation here
$menufile = "$ENV{'HOME'}/.kde/share/apps/kdisknav/$headerdir/$line.kdelnk";
open(TMPFILE, ">$menufile"); 			 	
print TMPFILE "# KDE Config File\n"; 			 	
print TMPFILE "[KDE Desktop Entry]\n";
print TMPFILE "URL=";
		} elsif ($i == 3) { 			chop($line);
# Some more kde stuff- I suppose someone could makes some nice .xpms?
                print TMPFILE "$line\n";
		print TMPFILE "Icon=www.xpm\n";
		print TMPFILE "MiniIcon=www.xpm\n";
		print TMPFILE "Type=Link\n";
close(TMPFILE);
		} 	}
}

close(SOCK) || die "Error closing socket: $!";
close(TMPFILE);
exit();

sub wmdie {
	my $string = shift;
	if ($string ne "") {
		print "$string\n";
	}
	
	close(SOCK);
	close(TMPFILE);
	
	exit(1);
}