/**************************************************************************
* Xtrophy ICQ - Originally written by tnc (xtrophy@it.dk)                 *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* config.cc                                                               *
* Handle the config files and such..                                      *
**************************************************************************/

// #include "main.h"

USER_CONFIGURATION user_cfg;

/*
**
** Sets the options for the user
*/
void userConfigure( USER_CONFIGURATION *user_cfg )
{
    char * string;
    char *config_file;
    char *home;
    home = getenv( "HOME" );

    user_cfg->uin	= 0;
    if ( user_cfg->password	!= NULL ) free( user_cfg->password );
    user_cfg->password	= NULL;
    if ( user_cfg->nick	!= NULL ) free( user_cfg->nick );
    user_cfg->nick	= NULL;
    if ( user_cfg->firstName	!= NULL ) free( user_cfg->firstName );
    user_cfg->firstName	= NULL;
    if ( user_cfg->lastName	!= NULL ) free( user_cfg->lastName );
    user_cfg->lastName	= NULL;
    if ( user_cfg->email	!= NULL ) free( user_cfg->email );
    user_cfg->email	= NULL;
    if ( user_cfg->logfile	!= NULL ) free( user_cfg->logfile );
    user_cfg->logfile	= NULL;
    user_cfg->defaultStatus	= 0;
    if ( user_cfg->contactList	!= NULL ) free( user_cfg->contactList );
    user_cfg->contactList	= NULL;
    if ( user_cfg->serverAddr	!= NULL ) free( user_cfg->serverAddr );
    user_cfg->serverAddr	= NULL;
    user_cfg->serverPort	= 0;
    user_cfg->clientPort	= 0;

    asprintf( &config_file, "%s/%s", home, CONFIG_FILE );

    string = ( char * ) malloc( BUFSIZE );
    ifstream configFile( config_file, ios::in );
    if ( !configFile ) {
        //        MY_PRINTF(color.none, "Couldn't open %s.\n", config_file);
        free ( string );
        free( home );
    } else {
        while ( configFile.getline( string, BUFSIZE ) ) {
            if ( !( strlen( string ) == 1 && string[ 0 ] == '\n' ) && strlen( string ) != 0 ) {
                if ( string[ 0 ] != '#' ) {
                    char * tmp;

                    tmp = strtok( string, "=" );
                    if ( !strcmp( tmp, "UIN" ) ) {
                        user_cfg->uin = atoi( strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "PASSWORD" ) ) {
                        asprintf( &user_cfg->password, "%s", strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "NICK" ) ) {
                        asprintf( &user_cfg->nick, "%s", strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "FIRSTNAME" ) ) {
                        asprintf( &user_cfg->firstName, "%s", strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "LASTNAME" ) ) {
                        asprintf( &user_cfg->lastName, "%s", strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "EMAIL" ) ) {
                        asprintf( &user_cfg->email, "%s", strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "ICQSERVER" ) ) {
                        asprintf( &user_cfg->serverAddr, "%s", strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "LOGFILE" ) ) {
                        asprintf( &user_cfg->logfile, "%s/%s", home, strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "CONTACT_FILE" ) ) {
                        asprintf( &user_cfg->contactList, "%s/%s", home, strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "ICQPORT" ) ) {
                        user_cfg->serverPort = atoi( strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "STATUS" ) ) {
                        user_cfg->status = atoi( strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "SHOWOFFLINE" ) ) {
                        tmp = strtok( NULL, "" );

                        tmp[ 0 ] = toupper( tmp[ 0 ] );
                        if ( tmp[ 0 ] == '1' || tmp[ 0 ] == 'T' || tmp[ 0 ] == 'Y' )
                            user_cfg->showoffline = 1;
                        else
                            user_cfg->showoffline = 0;
                    } else if ( !strcmp( tmp, "COL_TITLEB" ) ) {
                        sprintf( color.titleB, "%c[%sm", '\033', strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "COL_TITLED" ) ) {
                        sprintf( color.titleD, "%c[%sm", '\033', strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "COL_BORDER" ) ) {
                        sprintf( color.border, "%c[%sm", '\033', strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "COL_HEADER" ) ) {
                        sprintf( color.header, "%c[%sm", '\033', strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "COL_TEXT" ) ) {
                        sprintf( color.text, "%c[%sm", '\033', strtok( NULL, "" ) );
                    } else if ( !strcmp( tmp, "COL_NONE" ) ) {
                        sprintf( color.none, "%c[%sm", '\033', strtok( NULL, "" ) );
                    }
                }
            }
        }
        configFile.close();
        free ( string );
        free( home );
    }
}
