/*
   $Id: users.cpp,v 2.25.4.1.2.3 1998/12/20 21:01:59 herwinjs Exp $
*/

#include <qframe.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <kiconloader.h>
#include <qwmatrix.h>
#include <qrect.h>
#include <qwmatrix.h>
#include <qpicture.h>
#include <qdict.h>
#include <qintdict.h>
#include "kxicq.h"
#include "dialogs.h"
#include "sendDialog.h"

#define ID_POPUP_MSG 1
#define ID_POPUP_CHAT 2
#define ID_POPUP_INFO 3
#define ID_POPUP_DELETE 4
#define ID_POPUP_ADD 5

extern struct kxicqConfig KxicqConfig;
extern int logged_on;
extern mainWin *mainW;
extern KApplication *mainApp;
extern QList < MSG > userMsg;
viewSearch *viewS;
userInfo *userI;
int isViewSearch ;
int isDoSearch ;
connectTalk *newOneMsg;
QList < connectTalk > talkConnect;
int stopAll;
extern DockView *dockView;
int showOffline = 2;  //type of windows layout, 0 = only offline, 1 = old KXicq style, 2 = m$icq style
int OldStyle = 1;
extern USER_CONFIGURATION user_cfg;

Users::Users( QWidget* parent, const char* name )
        : QWidget( parent, name )
{
    split = new QSplitter( this );

    wa=new QWidget(split);
    wo=new QWidget(split);
    
    QVBoxLayout *vb=new QVBoxLayout(wa);

    QLabel *l=new QLabel(wa);
    l->setText(i18n("Online Users"));
    l->setFixedHeight(20);
    l->setFrameStyle( QFrame::Raised | QFrame::Panel );
    vb->addWidget(l);
    
    avail = new userView( VIEW_ONLINE, wa );
    vb->addWidget(avail);
    vb->activate();

    vb=new QVBoxLayout(wo);

    l=new QLabel(wo);
    l->setText(i18n("Offline Users"));
    l->setFixedHeight(20);
    l->setFrameStyle( QFrame::Raised | QFrame::Panel );
    vb->addWidget(l);

    offl = new userView( VIEW_OFFLINE, wo );
    vb->addWidget(offl);
    vb->activate();



}

Users::~Users()
{
    delete offl;
    delete avail;

}

int Users::getView()
{
    return OldStyle;
}

void Users::setNewView( int s )
{
    switch ( s )
    {
        case 1:
            setOldStyle();
            break;
        case 2:
            setMSStyle();
            break;
        case 3:
            setOnlineOnly();
            break;
    }
}

void Users::setOldStyle()
{
    split->setOrientation( QSplitter::Horizontal );
    mainW->setMinimumSize( 385, 200 );
    switch ( OldStyle )
    {
        case 3:
            wo->setMaximumHeight( 4000 );
            wo->resize( ( width() / 2 ) - 7, height() );
            wa->resize( ( width() / 2 ) - 7, height() );
            break;
    }
    OldStyle = 1;
    split->repaint();
    mainW->repaint();
    wo->repaint();
    wa->repaint();

}
void Users::setMSStyle()
{
    split->setOrientation( QSplitter::Vertical );
    mainW->setMinimumSize( 195, 200 );
    //mainW->resize( 195, mainW->height() );
    switch ( OldStyle )
    {
        case 3:
            wo->setMaximumHeight( 4000 );
            wo->resize( width(), ( height() / 2 ) - 7 );
            break;
    }
    OldStyle = 2;
    split->repaint();
    mainW->repaint();
    wo->repaint();
    wa->repaint();

}
void Users::setOnlineOnly()
{
    split->setOrientation( QSplitter::Vertical );
    mainW->setMinimumSize( 195, 200 );
    //mainW->resize( 195, mainW->height() );
    OldStyle = 3;
    wo->resize( width(), 1 );
    wa->resize( width(), height()-1);
    wo->setMaximumHeight( 1 );
    split->repaint();
    mainW->repaint();
    wo->repaint();
    wa->repaint();
}
void Users::unSelectAll( int t )
{
    if ( t == 0 )
    {
        //      offl->unmarkAll();
    }
    else
    {
        //      avail->unmarkAll();
    }
}

void Users::highlight1( int, int )
{
    //   avail->unmarkAll();
}
void Users::highlight2( int, int )
{
    //   offl->unmarkAll();
}
void Users::insertItem( UIN status, QString nick, UIN uin, int r, int ir )
{


}

void Users::changeItem( UIN uin )
{
    offl->changeItem( uin );
    avail->changeItem( uin );

}

void Users::changeNick( UIN uin, char *nick, int status )
{
}

int Users::addItem( UIN uin )
{
    return 1;
}

void Users::doSetUnRead( UIN uin )
{
}

bool Users::eventFilter( QObject *obj, QEvent *event )
{
    return TRUE;
}

void Users::updateView()
{
    repaint();
}

void Users::mousePressEvent( QMouseEvent *m )
{
}
void Users::doMouseEvent( QMouseEvent * )
{
}
void Users::resizeEvent( QResizeEvent * )
{
    if ( showOffline ) split->resize( width(), height() );
    else
    {
        avail->resize( ( width() ) - 4, height() );
    }
}
