/* qmdirdrag.cpp
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <01-Nov-1998 14:30:12 marius>
 */

#include "qmdirdrag.h"

/*!
  \class QmDirDrag qmdirdrag.h
  \brief

  "inode/directory" MIME type is based on the KDE MIME type.
*/


/*!

*/

QmDirDrag::QmDirDrag(
    const char *DirPath,
    QWidget *pDragSource,
    const char *Name)
    : QStoredDrag("inode/directory", pDragSource, Name)
{
    int l = qstrlen(DirPath);
    QByteArray tmp(l);
    memcpy(tmp.data(), DirPath, l);
    setEncodedData(tmp);
}


/*!

*/

bool
QmDirDrag::canDecode(
    QDragMoveEvent* e)
{
    return e->provides("inode/directory");
}

/*!
  Decode it into a string.
*/

bool
QmDirDrag::decode(
    QDropEvent *e,
    QString &str)
{
    QByteArray payload = e->data("inode/directory");
    
    if(payload.size())
    {
	e->accept();
	str = QString(payload.size() + 1);
	memcpy(str.data(), payload.data(), payload.size());
	str[(int)payload.size()] = '\0';
	return true;
    }
    
    return false;
}





