/* ;-*-c++-*-
 * 
 * qmfilelist.h
 * 
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <08-Feb-1999 05:23:27 amos>
 */

#ifndef QMFILELIST_H_INCLUDED
#define QMFILELIST_H_INCLUDED

#include <qcombobox.h>
#include <qlineedit.h>
#include <qpixmap.h>
#include <qtabbar.h>

//  #include "qmthumbnaillist.h"
#include "QaThumbnailListview.hpp"
#include "qmtabbar.h"
#include "qmdetaillist.h"

class QmFileList : public QWidget
{
    Q_OBJECT
    
public:
    QmFileList(QWidget *Parent = 0,
	       const char *Name = 0);
    virtual ~QmFileList();

    QWidget		*visibleWidget(void) const;
    
signals:
    /*!
      \fn void QmFileList::fileHighlighted(const char *Filename)

      This signal is emitted whenever a file is highlighted.
    */
    
    void		fileHighlighted(const char *Filename);

    
    /*!
      \fn void QmFileList::fileSelected(const char *Filename)

      This signal is emitted whenever a file is selected.
    */
    
    void		fileSelected(const char *Filename);


    /*!
      \fn void QmFileList::dirSelected(const char *Dirname)

      This signal is emitted whenever a directory is selected.
    */

    void		dirSelected(const char *Dirname);

public slots:
    void		setPath(const char *NewPath);
    void		queryNextImage();
    void		queryPrevImage();
	void		showing( QWidget *w );

protected:
    virtual void	keyReleaseEvent(QKeyEvent *e);
    virtual bool	eventFilter(QObject *o, QEvent *e);
    
private:
    QListViewItem *	highlightNextImage(QListViewItem *);
    QListViewItem *	highlightPrevImage(QListViewItem *);
    
    QmTabBar		*pTabBar;
    QComboBox		*pFilter;
    QLineEdit		*pPath;
    QmDetailList	*pFileList;
//      QmThumbnailList	*pThumbnails;
    QaThumbnailListview	*pThumbnails;
    QString		CurrentDir;
    QPixmap		FolderIcon;
	QDir		Directory;
	QFileInfoList DirList;

    int			ThumbnailsID;
    int			FileListID;

private slots:
    void 		pathChanged();
    void 		itemHighlighted(QListViewItem *pItem);
    void 		itemSelected(QListViewItem *pItem);
	void		itemSelected(QaThumbnailItem *pItem);
    void		itemSelected(const char *Filename);
};

#endif // QMFILELIST_H_INCLUDED
