/* qmhotlist.cpp
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <17-Oct-1998 18:07:44 marius>
 */

#include <iostream.h>

#include <qdir.h>
#include <qdragobject.h>

#include "qmhotlist.h"
#include "qmlistviewitem.h"
#include "qmdirdrag.h"

/*!
  \class QmHotList qmhotlist.h
  \brief


*/


/*!

*/

QmHotList::QmHotList(
    QWidget *Parent,
    const char *Name)
    : QmListView(Parent, Name)
{
    pContextMenu = new QPopupMenu;
    pContextMenu->insertItem("Rename bookmark", this, SLOT(renameItem()));
    pContextMenu->insertItem("Remove bookmark", this, SLOT(removeItem()));
}


/*!

*/

QmHotList::~QmHotList()
{
}

/*
QmHotList::QmHotList(
    const QmHotList &Other)
{
}


const QmHotList &
QmHotList::operator=(
    const QmHotList &Other)
{
    if(this != &Other) // beware of self-assignment
    {
	delete pContextMenu;

	pContextMenu = new QPopupMenu;
	pContextMenu->insertItem("Rename bookmark", this, SLOT(renameItem()));
	pContextMenu->insertItem("Remove bookmark", this, SLOT(removeItem()));
    }

    return *this;
}
*/

/*!

 */

void
QmHotList::renameItem()
{
    cout << "rename\n";
}


/*!

 */

void
QmHotList::removeItem()
{
    ASSERT(currentItem() != 0);

    delete currentItem();
}


/*!

 */

void
QmHotList::dropEvent(
    QDropEvent *e)
{
    // Try to decode to the data

    QString str;
    if(QmDirDrag::decode(e, str))
    {
	// BUG: This won't work the first time.
	
	triggerUpdate();

	str = QDir::cleanDirPath(str);
	
	// Insert the directory name like this (numbers = column):
	// 1:   2:
	// bar  /a/directory/called/foo/bar
	
	(void) new QmListViewItem(
	    this,
	    str.right(str.length() - str.findRev('/') - 1),
	    str);

	// Update scrollbars
	
	return;
    }
}


/*!

 */

void
QmHotList::dragEnterEvent(
    QDragEnterEvent *e)
{
//    cout << "QmListView::dragEnterEvent()\n";
    
    if(QmDirDrag::canDecode(e))
    {
	e->accept();
    }

    // Give the user some feedback (types out the format types)
    
//     QString t;
//     for(int i = 0; e->format(i); i++)
//     {
// 	if(*(e->format(i)))
// 	{
// 	    if( ! t.isEmpty())
// 		t += "\n";
// 	    t += e->format(i);

// 	    cout << t << endl;
// 	}
//     }
}


/*!

 */

void
QmHotList::mousePressEvent(
    QMouseEvent *e)
{
    
    QmListView::mousePressEvent(e);

    // Check QListView::rightButtonClicked()

//    setSelected(itemAt(e->globalPos()), true);
    
    if(currentItem() != 0)
    {
	if(e->button() == RightButton)
	{
	    pContextMenu->popup(e->globalPos());
	}
    }
}
