/* qmimageviewbrowser.cpp
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <08-Feb-1999 05:54:41 amos>
 */

#include <qlayout.h>
#include <qsplitter.h>

#include "qmimageviewbrowser.h"
#include "qmpreviewitem.h"

/*!
  \class QmImageViewBrowser qmimageviewbrowser.h
  \brief The QmImageViewBrowser widget provides a full size view of
  \brief of an image aswell as thumbnail browsing of directories.

  
*/

/*
  A more flexible solution might be to have everything in QmBrowser,
  and take use of the QSplitter::moveToFirst() and QSplitter::moveToLast()
  functions, for a more customizable GUI.
*/

/*!

*/

QmImageViewBrowser::QmImageViewBrowser(
    QWidget *Parent,
    const char *Name)
    : QWidget(Parent, Name)
{
    QBoxLayout *pMainLayout = new QHBoxLayout(this, 2);

    QSplitter *pSplit = new QSplitter(QSplitter::Horizontal, this);

    pThumbnailList = new QmListView(pSplit);
    {
	pThumbnailList->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
	
	pThumbnailList->addColumn("Filename", 170);
	pThumbnailList->setColumnWidthMode(0, QListView::Manual);
	pThumbnailList->setMaximumWidth( pThumbnailList->sizeHint().width() );
	pThumbnailList->setMinimumWidth( 0 );
	pThumbnailList->resize( 0, pThumbnailList->height() );
	pThumbnailList->hide();

	/*
	QListViewItem *i;
	Pixmap.load("/opt/graphics/pics/new/backgr~1/bblubal.gif");

	for(int j = 0; j < 100; j++)
	{
	    i = new QListViewItem(pThumbnailList);
	    i->setPixmap(0, Pixmap);
	    i->setText(1, "Bla");
	}
	*/

	QFileInfo *fi1 = new QFileInfo("/usr/share/icons");
//  	QFileInfo *fi2 = new QFileInfo("/usr/src/linux/Documentation/logo.gif");
	
	QmPreviewItem *item;

	for(int j = 0; j < 30; j++)
	{
	    item = new QmPreviewItem(fi1, pThumbnailList);
//	    item->setText(0, "test");
	}
	
//	item = new QmPreviewItem(fi2, pThumbnailList);
//	item->setText(0, "test 2");
    }
    
    pImageView = new QmImageView(pSplit);
    {
		pImageView->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
		pImageView->setFocusPolicy( StrongFocus );
    }

    pMainLayout->addWidget(pSplit);
//    pSplit->hide();
//    pImageView->show();  
    pMainLayout->activate();
}


/*!

*/

QmImageViewBrowser::~QmImageViewBrowser()
{
}


/*!
  Loads the image specifieed by \a Filename. Returns true if the
  image was successfully loaded, false otherwise.
*/

bool
QmImageViewBrowser::loadImage(
    const char *Filename)
{
    return pImageView->loadImage(Filename);
}
