/* ;-*-c++-*-
 *
 * qminfoitem.h
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <01-Nov-1998 15:22:04 marius>
 */

#ifndef QMINFOITEM_H_INCLUDED
#define QMINFOITEM_H_INCLUDED

#include <qfileinfo.h>

#include "qmlistviewitem.h"

class QmInfoItem : public QmListViewItem
{
public:
    QmInfoItem(QFileInfo *pNewFileInfo, QListView *Parent);
    QmInfoItem(QFileInfo *pNewFileInfo, QmListViewItem *Parent);
    virtual ~QmInfoItem();

    const char		*key(int Column, bool Ascending) const;
    const char		*text(int Column) const;
    const QPixmap	*pixmap(int Column) const;

    virtual void	paintCell(QPainter *p, const QColorGroup &cg,
				  int col, int width, int align);

    static QString	friendlySize(long Value);
    const QFileInfo	*fileInfo(void) const;

    enum
    {
	Name = 0,
	Size,
	Type,
	Modified,
	Permission
    };

    enum
    {
	Jpg = 0,
	Gif,
	Xpm,
	Png,
	Unknown
    };

private:
    void		initialize(void);

    QFileInfo		FileInfo;
    int			ImageType;
    QColorGroup		ColorGroup;
};

#endif // QMINFOITEM_H_INCLUDED


