/* qmlistviewitem.cpp
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <03-Oct-1998 20:13:47 marius>
 */

#include <qlistview.h>

#include "qmlistviewitem.h"

/*!
  \class QmListViewItem qmlistviewitem.h
  \brief The QmListViewItem class is a slight customization of QListViewItem.

  It adds a little frame around the currently highlighted frame if the
  item (listview) has the focus, like QListBox does.

  I can't get this to work though :-/
*/

QmListViewItem::QmListViewItem(
    QListView *Parent)
    : QListViewItem(Parent)
{
}

QmListViewItem::QmListViewItem(
    QListViewItem *Parent)
    : QListViewItem(Parent)
{
}

QmListViewItem::QmListViewItem(
    QListView *Parent,
    const char *s1,
    const char *s2,
    const char *s3,
    const char *s4,
    const char *s5,
    const char *s6,
    const char *s7,
    const char *s8)
    : QListViewItem(Parent, s1, s2, s3, s4, s5, s6, s7, s8)
{
}

QmListViewItem::QmListViewItem(
    QListViewItem *Parent,
    const char *s1,
    const char *s2,
    const char *s3,
    const char *s4,
    const char *s5,
    const char *s6,
    const char *s7,
    const char *s8)
    : QListViewItem(Parent, s1, s2, s3, s4, s5, s6, s7, s8)
{
}

QmListViewItem::~QmListViewItem()
{
}


/*!
  Paints a focus indication on the rectangle \a r using painter \a p and
  colors \a cg.
*/

void
QmListViewItem::paintFocus(
    QPainter *p,
    const QColorGroup &cg,
    const QRect &r)
{
    if(listView()->style() == WindowsStyle)
    {
	// I don't care about the Windows style. I'll leave that to Qt:
	
	QListViewItem::paintFocus(p, cg, r);
    }
    else
    {
 	if(isSelected())
 	    p->setPen(cg.base());
 	else
 	    p->setPen(cg.text());

	p->drawWinFocusRect( r );
//	p->drawRect(r.x() + 1, r.y() + 1, r.right() - 1, r.bottom() - 1);
	
// 	p->drawRect(1, 1,
// //		    width(listView()->fontMetrics(), listView(),) - 1,
// 		    r.right() - 1,
// 		    height() - 1);
    }
}
