/* ;-*-c++-*-
 *
 * qmmainwindow.h
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <08-Feb-1999 07:03:44 amos>
 */

#ifndef QMMAINWINDOW_H_INCLUDED
#define QMMAINWINDOW_H_INCLUDED

#include <qfileinfo.h>
#include <qframe.h>
#include <qimage.h>
#include <qlabel.h>
#include <qlistview.h>
#include <qmainwindow.h>
#include <qpixmap.h>
#include <qpopupmenu.h>
#include <qscrollview.h>
#include <qstatusbar.h>
#include <qtimer.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qwidgetstack.h>

#include "qmimageview.h"
#include "qmimageviewbrowser.h"
#include "qmbrowser.h"

class QmMainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    QmMainWindow(QWidget *Parent = 0,
		 const char *Name = 0);
    virtual ~QmMainWindow();

    static bool		deleteItem(const QFileInfo &ItemToDelete);
    static bool		deleteItem(const char *FileToDelete);
	void setPictureFile( QString fname );
	void setPath( QString dir );
	QString getIconPath( QString name );

private:
    void		updateWindowMenu(void);

    QComboBox		*pZoom;
    QFrame		*pImage;
    QImage		TheImage;
    QLabel		*pInfo;
    QPopupMenu		*pControlsMenu;
    QTimer		*pSlideshowTimer;
    QToolBar		*pToolBar;
    QToolButton		*pSlide;
    QToolButton		*pZoomIn;
    QToolButton		*pZoomOut;
    QToolButton		*pBack;
    QToolButton		*pForward;
    QWidgetStack	*pStack;
    QmBrowser		*pBrowser;
    QmImageView		*pImageView;
    
    static QPopupMenu	*pWindowMenu;
    static QList<QmMainWindow>	WindowList;
    
    int			MenuBarToggleID;
    int			PreviewToggleID;
    int			StatusBarToggleID;
    int			ToolBarToggleID;

    bool		ShowPreview;
    
    static const int	ImageViewID	= 1;
    static const int	BrowserID	= 2;
    static const int	ZoomStep	= 20;
    static const int	SlideshowWait	= 5000;
    
private slots:
    void closeWindow();
    void menuInfo(int MenuID);
    void newMainWindow();
    void nextImage();
    void prevImage();
    void showAbout();
    void showFormats();
    void showHelp();
    void showImage(const QPixmap &Pixmap);
    void showImage(const char *Filename);
    void showOptions();
    void showQtInfo();
    void toggleFullScreen();
    void toggleMenuBar();
    void togglePreview();
    void toggleSlideshow();
    void toggleStatusBar();
    void toggleToolBar();
    void toggleView();
    void zoomDown();
    void zoomEntered(const char *ZoomFactor);
    void zoomUp();
};

#endif // QMMAINWINDOW_H_INCLUDED
