/* ;-*-c++-*-
 * 
 * qmpreview.h
 * 
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <10-Jan-1999 12:19:18 marius>
 */

#ifndef QMPREVIEW_H_INCLUDED
#define QMPREVIEW_H_INCLUDED

#include <qbutton.h>
#include <qframe.h>
#include <qimage.h>
#include <qpixmap.h>

class QmPreview : public QButton
{
    Q_OBJECT
    
public:
    QmPreview(QWidget *Parent = 0,
	      const char *Name = 0);
    virtual ~QmPreview();
    
    void		setPixmap(const QPixmap &PixmapToPreview);
    void		setFilename(const QString &NewFilename);

signals:

    /*! \fn void QmPreview::clicked(QImage &Image)

      This signal is emitted when the preview button is clicked AND
      the preview contains an image.
      \a Image is the currently shown image.
    */

    void		clicked(const QPixmap &Pixmap);

    /*! \fn void QmPreview::clicked(const char *Filename)

      This signal is emitted when the preview button is clicked AND
      the preview contains an image. \a Filename is the filename
      associated with the thumbnail.
    */
    
    void		clicked(const char *Filename);

protected:
    virtual void	drawButton(QPainter *p);
    virtual void	drawButtonLabel(QPainter *p);
    QPixmap		scale(const QPixmap &OriginalPixmap) const;
    
private:    
    QPixmap		PixmapToShow;
    QString		Filename;
    QString		Label;
    int			LabelHeight;

private slots:
    void		previewClicked();
};

#endif // QMPREVIEW_H_INCLUDED
