/* qmpreviewitem.cpp
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <14-Dec-1998 21:12:51 marius>
 */

#include <iostream.h>

#include <qapplication.h>
#include <qimage.h>

#include "qmpreviewitem.h"

/*!
  \class QmPreviewItem qmpreviewitem.h
  \brief


*/

QString *tmpString2;
bool VariablesMade2 = false;

void cleanup2()
{
    delete tmpString2;
    tmpString2 = 0;
}

void makeVariables2()
{
    if( ! VariablesMade2) // I could check the tmpString2 pointer instead
    {
	VariablesMade2 = true;
	qAddPostRoutine(cleanup2);

	tmpString2 = new QString;
    }
}


/*!

*/

QmPreviewItem::QmPreviewItem(
    QFileInfo *pNewFileInfo,
    QListView *Parent)
    : QmListViewItem(Parent),
      FileInfo(*pNewFileInfo)
{
    makeVariables2();

    initialize();
}

QmPreviewItem::QmPreviewItem(
    QFileInfo *pNewFileInfo,
    QmListViewItem *Parent)
    : QmListViewItem(Parent),
      FileInfo(*pNewFileInfo)
{
    makeVariables2();

    initialize();
}


/*!

*/

QmPreviewItem::~QmPreviewItem()
{
}


/*!
  Returns a key for sorting.
*/

/*
  This function is necessary so that directories will be listed
  first, then files.
*/

const char *
QmPreviewItem::key(
    int Column,
    bool Ascending) const
{
    char MajorKey = Ascending == FileInfo.isDir() ? '0' : '1';

    *tmpString2 = text(Column);
    tmpString2->insert(0, MajorKey);

    return *tmpString2;
}


/*!
  Returns the text of the item.
*/

const char *
QmPreviewItem::text(
    int Column) const
{
    switch(Column)
    {
    case 0:
	*tmpString2 = FileInfo.fileName();
	break;

    default:
	*tmpString2 = "<--->";
	break;
    }

//    cout << "QmPreviewItem::text(" << Column << "): " << *tmpString2 << endl;

    tmpString2->detach();
    return *tmpString2;
}


/*!
  Returns an appropriate icon.
*/

const QPixmap *
QmPreviewItem::pixmap(
    int Column) const
{
    // The QFileIconProvider is neat. See if it can be used sometime ;-)
    
    if(Column)
	return 0;
    else/*(ImageType != Unknown)*/
	return &Thumbnail;
    /*
    else if(FileInfo.isDir())
	return folderIcon;
    else
	return fifteenTransparentPixels;
    */
}


void
QmPreviewItem::setup()
{
    QListViewItem::setup();
    setHeight(64);
}


void
QmPreviewItem::paintCell(
    QPainter *p,
    const QColorGroup &/*cg*/,
    int col, int width,
    int align)
{
    if( ! p)
	return;

    QmListViewItem::paintCell(p, ColorGroup, col, width, align);
}


/*!
  \internal
*/

void
QmPreviewItem::initialize(void)
{
    Thumbnail.load("/opt/graphics/pics/new/backgr~1/bblubal.gif");

    /*
    *tmpString2 = QImage::imageFormat(FileInfo.filePath());
    if(FileInfo.isFile())
    {
	if(*tmpString2 == "JPEG")
	{
	    ImageType = Jpg;
//	    ColorGroup = *pJpgCg;
	}
	else if(*tmpString2 == "GIF")
	{
	    ImageType = Gif;
//	    ColorGroup = *pGifCg;
	}
    
	else if(*tmpString2 == "XPM")
	{
	    ImageType = Xpm;
//	    ColorGroup = *pXpmCg;
	}
	else if(*tmpString2 == "PNG")
	{
	    ImageType = Png;
//	    ColorGroup = *pPngCg;
	}
	else
	{
	    ImageType = Unknown;
//	    ColorGroup = QApplication::palette()->normal();
	}
    }
    else
    */
    {
	ImageType = Unknown;
	ColorGroup = QApplication::palette()->normal();
    }
}





