/* ;-*-c++-*-
 * 
 * qmpreviewitem.h
 * 
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <14-Dec-1998 21:08:05 marius>
 */

#ifndef QMPREVIEWITEM_H_INCLUDED
#define QMPREVIEWITEM_H_INCLUDED

#include <qfileinfo.h>
#include <qpixmap.h>

#include "qmlistviewitem.h"

class QmPreviewItem : public QmListViewItem
{
public:
    QmPreviewItem(QFileInfo *pNewFileInfo, QListView *Parent);
    QmPreviewItem(QFileInfo *pNewFileInfo, QmListViewItem *Parent);
    virtual ~QmPreviewItem();

    const char		*key(int Column, bool Ascending) const;
    const char		*text(int Column) const;
    const QPixmap	*pixmap(int Column) const;

    virtual void	setup(void);

    virtual void	paintCell(QPainter *p, const QColorGroup &cg,
				  int col, int width, int align);
private:
    void		initialize(void);
    
    enum
    {
	Jpg = 0,
	Gif,
	Xpm,
	Png,
	Unknown
    };

    QFileInfo		FileInfo;
    int			ImageType;
    QPixmap		Thumbnail;
    QColorGroup		ColorGroup;
};

#endif // QMPREVIEWITEM_H_INCLUDED


