/* ;-*-c++-*-
 * 
 * qmthumbnaillist.h
 * 
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <09-Jan-1999 23:24:06 marius>
 */

#ifndef QMTHUMBNAILLIST_H_INCLUDED
#define QMTHUMBNAILLIST_H_INCLUDED

//#include <qdir.h> // I get compile error if I include this!!!!!
#include <qlist.h>
#include <qscrollview.h>

#include "qmpreview.h"

class QmThumbnailList : public QScrollView
{
    Q_OBJECT
    
public:
    QmThumbnailList(QWidget *Parent = 0,
		    const char *Name = 0);
    virtual ~QmThumbnailList();

//    void setPath(QDir NewDir);
    void setPath(QString Path);

signals:
    /*! \fn void QmThumbnailList::selected(const char *Filename)
     *
     * This signal is emitted whenever a thumbnail is clicked.
     * \a Filename is the filename (including path) associated to
     * the thumbnail being clicked.
     */
    
    void selected(const char *Filename);

    /*! \fn void QmThumbnailList::dirSelected(const char *Directory)
     *
     * This signal is emitted whenever a directory is clicked.
     * \a Directory is the full path.
     */
    
    void dirSelected(const char *Directory);

protected:
    void drawContentsOffset(QPainter *p, int OffsetX, int OffsetY,
			    int ClipX, int ClipY,
			    int ClipW, int ClipH);
    void resizeEvent(QResizeEvent *e);
    
private:
    void appendIconBox(QmPreview *pNewIconBox);

    int			xPos;
    int			yPos;
    static const int	HSpacing = 10;
    static const int	VSpacing = 10;
    static const int	HSize = 90;
    static const int	VSize = 90;
//    QDir		TheDir;
    QList<QWidget>	ChildList;

    void debug(void);

private slots:
    void thumbnailClicked(const char *Filename);
    void directoryClicked(const char *Directory);
};

#endif // QMTHUMBNAILLIST_H_INCLUDED






