/* ;-*-c++-*-
 * 
 * strings.h
 * 
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <02-Nov-1998 20:10:02 marius>
 */

/* This file contains most of the longer strings in the program, e.g.
 * tooltips and What's This help texts.
 *
 * TT = Tooltip
 * WT = What's This
 * SB = Statusbar
 */

#define TT_HOT_LIST "Drag and drop directories here."
#define WT_HOT_LIST \
"A hotlist of directories.\n" \
"\n" \
"Here you can have directories you often access. " \
"This would typically be directories you collect " \
"your images in.\n" \
"\n" \
"To add a directory, use the filelist at the " \
"right, locate the directory you want to add, " \
"drag it from there and drop it here.\n" \
"\n" \
"The `Name' column is just for convenience. It'll " \
"default to the last part of the path. That is, " \
"if you drag a directory with the path " \
"/usr/local/bin, `bin' will be the name. To " \
"change the name, click on it with the right " \
"mouse button and select `Rename bookmark'.\n" \
"\n" \
"To remove a directory from the list (it won't be " \
"deleted from the disk, of course), click on it " \
"with the right mouse button and select " \
"`Remove bookmark'."

#define WT_PREVIEW \
"Shows a preview of the last highlighted image. " \
"Click on it to show the image in its full size. " \
"You can resize the preview by dragging the splitters " \
"at the top and at the right.\n" \
"\n" \
"The preview can be disabled by unchecking `Preview' " \
"in the Settings menu."

#define TT_PATH "The path currently listed."
#define WT_PATH \
"The path currently listed. You can enter a path " \
"here and press Enter to list it. If nothing happens " \
"and you only hear a beep, the path you entered does " \
"not exist. Try again. Remember that paths are case " \
"sensitive. That is, /Usr/local/bIn is not the same " \
"as /usr/local/bin.\n" \
"\n" \
"Soon to come: Tab completion ;-)"

#define TT_FOLDER_ICON "Click to list parent directory?"
#define WT_FOLDER_ICON \
"This icon represents the current listed directory. " \
"It can be dragged to e.g. the Hotlist."

#define TT_FILTER "Enter file display filter"
#define WT_FILTER \
"Enter the file display filter here, or " \
"select one from the list.\n" \
"\n" \
"A display filter determines which files to show. " \
"For example, if you only want to see JPEG images in " \
"the file list, enter `*.jpg'.\n" \
"\n" \
"Note that the filter is case sensitive. That is, " \
"the above example would only list files ending with " \
"exactly `jpg', and not `JPG' or `Jpg'."

#define WT_FILE_LIST \
"The list of files and directories. Single click " \
"on an image to see a preview at the bottom-left." \
"Note that `Preview' must be on in the Settings " \
"menu for this to work. Double click on the image " \
"to view it in its full size.\n" \
"\n" \
"If you have more than one window of this " \
"application open, you can drag an image filename " \
"from this list and to an imageview in another " \
"window to show it there."

#define WT_BACK \
"Click this to go to the previous picture. If the " \
"current picture is the first picture, the last " \
"picture will be shown, i.e. it'll wrap around."

#define WT_FORWARD \
"Click this to go to the next picture. If the " \
"current picture is the last picture, the first " \
"picture will be shown, i.e. it'll wrap around."

#define WT_ZOOM_IN "Zooms in by 10%"
#define WT_ZOOM_OUT "Zooms out by 10%"
#define WT_SLIDE_SHOW "Start/stop slideshow"

#define WT_IMAGE_VIEW \
"Shows the image in its full size.\n" \
"\n" \
"If the image is larger than the window, you can " \
"scoll it by pressing and moving the right mouse " \
"button. You can also use the cursor keys.\n" \
"\n" \
"If you have another window of this application open, " \
"you can drag this image into another imageview to " \
"show it there.\n" \
"\n" \
"Keys:\n" \
" Space     - Next image\n" \
" Backspace - Previous image\n" \
" Delete    - Delete the image (Caution!)\n"


