/*	MikMod sound library
	(c) 1998 Miodrag Vallat and others - see file AUTHORS for complete list

	This library is free software; you can redistribute it and/or modify
	it under the terms of the GNU Library General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Library General Public License for more details.
 
	You should have received a copy of the GNU Library General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Modified 2/1/99 for x11amp by J. Nick Koston (BlueDraco)
*/

/*==============================================================================

  $Id: drv_x11amp.c,v 1.16 1998/12/07 06:01:48 miod Exp $

  Output data to x11amp

==============================================================================*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <stdlib.h>

#include "mikmod-plugin.h"

#include <mikmod_internals.h>

#define BUFFERSIZE 32768

static	SBYTE *audiobuffer=NULL;

static BOOL x11amp_IsThere(void)
{
	return;
}

static BOOL x11amp_Init(void)
{
	if(!(audiobuffer=(SBYTE*)_mm_malloc(BUFFERSIZE))) return 1;
	return VC_Init();
}

static void x11amp_Exit(void)
{
	VC_Exit();
	if (audiobuffer) {
		free(audiobuffer);
		audiobuffer=NULL;
	}
}

static void x11amp_Update(void)
{
	if(ip.output->buffer_free()>=BUFFERSIZE) {
		ip.output->write_audio(audiobuffer,VC_WriteBytes((SBYTE*)audiobuffer,BUFFERSIZE));
	} else {
		usleep(10000);
	}
}

static BOOL x11amp_Reset(void)
{
	VC_Exit();
	return VC_Init();
}

MDRIVER drv_x11amp={
	NULL,
	"x11amp",
	"x11amp output driver v1.0",
	0,255,
	x11amp_IsThere,
	VC_SampleLoad,
	VC_SampleUnload,
	VC_SampleSpace,
	VC_SampleLength,
	x11amp_Init,
	x11amp_Exit,
	x11amp_Reset,
	VC_SetNumVoices,
	VC_PlayStart,
	VC_PlayStop,
	x11amp_Update,
	VC_VoiceSetVolume,
	VC_VoiceSetFrequency,
	VC_VoiceSetPanning,
	VC_VoicePlay,
	VC_VoiceStop,
	VC_VoiceStopped,
	VC_VoiceGetPosition,
	VC_VoiceRealVolume
};
