/*  x11amp - graphically mp3 player..
 *  Copyright (C) 1998-1999  Mikael Alm, Olle Hallnas, Thomas Nilsson and 4Front Technologies
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef PLAYLIST_H
#define PLAYLIST_H

typedef struct
{
	gchar		*filename;
	gchar 		*title;
	gint		length;
	gboolean	selected;
} PlaylistEntry;

void playlist_clear(void);
void playlist_delete(gboolean crop);
void playlist_select_all(void);
void playlist_select_none(void);
void playlist_inverse_selection(void);
void playlist_add(gchar *filename);
void playlist_add_dir(gchar *dir);
void playlist_add_url_string(gchar *string);
void playlist_play(void);
void playlist_set_info(gchar *title,gint length,gint rate,gint freq,gint nch);
void playlist_next(void);
void playlist_prev(void);
void playlist_eof_reached(void);
void playlist_set_position(gint pos);
gint get_playlist_length(void);
gchar *playlist_get_info_text(void);
int playlist_get_current_length(void);
gboolean playlist_save(gchar *filename);
gboolean playlist_load(gchar *filename);
GList *get_playlist(void);
void playlist_generate_shuffle_list(void);


#endif
