/* x11amp mpeg audio decoding plugin using the xaudio decoder, 
   http://www.xaudio.com/
   
   copyright, 1999, Dj-Ohki@fuse.net
   http://balthasar.tzo.com/

   patches are welcome, just dont go off and distrubute your own version,
   send me patches, ill include them in the distro
   (last thing i need is 10 diffrent versions floating around)
   
   this contains no warranty, if it wipes your hdd, dont come crying,
   but if there is a problem, and you can be polite about it, join 
   #x11amp on efnet, there should be someone there who can help

   not implemented yet : 
       Shoutcast (v1.1 will support shoutcast)
       FFT display (GRRR......)
       8 bit mode (if someone needs it, ill implement it)

   bugs : 
           not really a bug in the plugin, but the whole eq setup...
	   xaudio has 32 bands of eq (one per band of the mpeg stream),
	   [x11|win]amp has 10 critcal bands. thus, the freqs dont match 
	   up in the window.  right now im not too worried about this,
	   if a lot of ppl start to complain about it, ill implement 
	   a true FFT/bandpass eq... but it will be a big cpu sucker
	   (another thing,i could make a sep dialog to set the xaudio
	   bands (32 stereo bands), *shrug* tell me what you want)

   shouts : 
           The x11amp crew, Psychotron, Fatal, and Crocodile
	   The xaudio crew for making a kick ass decoder 
	         (and great tech support!)
	   #x11amp on efnet! (they make great test subjects :P )
	   #anime_supreme on dalnet! 
*/
/*remove the next line to make the eq more sensitive, but have less bandwith*/
#define BIG_EQ 1


#include "xa.h"

InputPlugin ip=
{
	NULL,
	NULL,
	"x11amp Xaudio plugin, version 1.1pre5+a2, Dj-Ohki",
	init,
	NULL,
	NULL,
	is_our_file,
	play_file,
	stop,
	xa_pause,
	seek,
	set_eq,
	get_time,
        NULL,
	NULL,
	NULL
};
	
pthread_t decode_thread;;
pthread_mutex_t memory=PTHREAD_MUTEX_INITIALIZER;
int die;
int playing;
int paused;

XA_DecoderInfo *decoder;
InputPlugin *get_iplugin_info(void)
{
	return &ip;
}

void init(void)
{
  int i;
  paused=0;
  printf("makes use of the xaudio libarary, version %s, http://www.xaudio.com/\n",decoder_version(NULL,NULL,NULL));
  playing=0;

  if(decoder_new(&decoder)!= XA_SUCCESS)
    {
      printf("xaudio croked during init, this shouldnt happen\n");
      printf("please contact Dj-Ohki@fuse.net and report this\n");
      exit(-1);
    }
  {
    XA_InputModule module;
    file_input_module_register(&module);
    decoder_input_module_register(decoder,&module);
  }
}

int is_our_file(char *filename)
{
  char *ext;
  ext=strrchr(filename,'.');
  if(ext!=0)
    if(!strcasecmp(ext,".mp3"))
      return 1;
  return 0;
}
void *play_loop(void *arg)
{
  int i,size,chunks,status=XA_SUCCESS;
  void *buffer;
  short *buffer2;
  playing=1;
  chunks=9; /*this gives us a nice 512 byte size chunk, i think...
	      at least for 44100 rate.. 
	      512 byte -> 256 stereo samples -> 128 samples per channel
	    */
  ip.output->flush(0);
  do {

    while((ip.output->buffer_free()<decoder->output_buffer->size)&&die==0)
      usleep(10000);
    
    buffer=decoder->output_buffer->pcm_samples;
    size=decoder->output_buffer->size/chunks;
    for(i=0;i<chunks;i++)
      {
	ip.output->write_audio(buffer,size);
	buffer+=size;
      }
    fft(size,
	decoder->output_buffer->bytes_per_sample,
	decoder->output_buffer->pcm_samples);
    pthread_mutex_lock(&memory);
    status = decoder_decode(decoder, NULL);
    pthread_mutex_unlock(&memory);
  } while((status == XA_SUCCESS ||
	   status == XA_ERROR_TIMEOUT ||
	   status == XA_ERROR_INVALID_FRAME)
	  && die == 0);
  if (status == XA_ERROR_INPUT_EOF){
    while((i=(ip.output->written_time()-ip.output->output_time()))>0){
      if(i > 0)
	usleep (i*1000);
      else
	usleep (2000000);
    }
  }
  ip.output->flush(0);
  ip.output->close_audio();
  decoder_input_delete(decoder);  
  playing=0;
  pthread_exit(NULL);
}

void play_file(char *filename)
{
  int status;
  char *shortfile = (char *) rindex(filename, '/'); /*thx vi! */
  die=0;
  status=decoder_input_new(decoder,filename,XA_DECODER_INPUT_AUTOSELECT);
  if (status != XA_SUCCESS)
    { 
      printf("error in file open (%s) %d\n",filename,status);
      return;
    }
  if((status=decoder_input_open(decoder))!=XA_SUCCESS)
    {
      printf("cannot open input (%i),check your file permissions\n",status);
      /*oops, vi pointed out i didnt clear the mutex*/
      return;
    }
  playing=1;
  status=decoder_decode(decoder,NULL); 
  if(status==XA_SUCCESS){
    if(ip.output->open_audio(
			     FMT_S16_LE,/*anyone need 8bit?*/
			     decoder->output_buffer->sample_rate,
			     (decoder->output_buffer->stereo+1))==0)
      {
	printf("WAAA, the output plugin didnt like me...\n");
	return;
      }
    
    ip.set_info(
		++shortfile, /*thx again vi! */
		decoder->input->duration*1000,
		decoder->status->info.bitrate*1000,
		decoder->status->info.frequency,
		decoder->output_buffer->stereo+1);
    pthread_create(&decode_thread,NULL,play_loop,NULL);
  }
}

void stop(void)
{
  if (playing == 0)
    return;
  die=1;
  pthread_join(decode_thread,NULL);
}

void xa_pause(short p)
{
  paused=p;
  ip.output->pause(p);
}

void seek(int time)
{
  float pos;
  pos=time/(float)decoder->input->duration;
  decoder_input_seek_to_position(decoder,pos);
  ip.output->flush(time);
}

int get_time(void)
{
  int time = 0;
  if (playing == 0)
    return -1;
  time+=decoder->status->timecode.s;
  time+=decoder->status->timecode.m*60;
  time+=decoder->status->timecode.h*3600;
  
  time*=1000;
  return time;
}

void set_eq(int on,float pre,float *b){
  int i;
  int band;
  XA_EqualizerInfo eq;
  int eqband[]=
  {0,1,2,3,4,4,5,5,5,6,6,6,6,7,7,7,7,7,8,8,8,8,8,8,8,9,9,9,9,9,9,9};
  for (i=0;i<32;i++){
    if (on == 1){
#ifdef BIG_EQ
      eq.left[i] = eq.right[i] = (128/40) * (pre + b[eqband[i]]); /*+-9db*/    
#else  
      eq.left[i] = eq.right[i] = (128/80) * (pre + b[eqband[i]]); /*+-4db*/
#endif
         }
    else
      eq.left[i] = eq.right[i] = 0;
  }
  pthread_mutex_lock(&memory);
  decoder_codec_set_equalizer(decoder,&eq);
  pthread_mutex_unlock(&memory);
}	

static int r(int k, int n) {
    int r = 0;
    for(;n>1;n>>=1) {
      r=(r<<1)|(k&1);
      k>>=1;
    }
    return r;
}
inline complex cpxadd(complex a, complex b){
  complex i;
  i.r = a.r + b.r;
  i.i = a.i + b.i;
  return i;
}

void fft(int size,int chunks,void *buffer){
return;
/* 
  float a;
  int h, k;
  int p,kp,z, zp;
  int samplesize=sizeof(short);
  int samples = size/(chunks*2);
  complex c[samples];
  complex t;
  return;
  printf("size : %i\nsamplesize : %i\nsample : %i\n",size,samplesize,samples);
  for(k=0;k<samples;k++){
    memcpy(&(c[k].r),buffer,samplesize);
    buffer+=samplesize;
    memcpy(&(c[k].i),buffer,samplesize);
    buffer+=samplesize;
  }
 
  for (h=samples;h!=0;h>>=1){
    zp=0;
    for(k=0;k<samples;k++){
      if( (k & p) == 0) {
	kp=k+p;
	t.r = c[k].r + c[kp].r;
	t.i = c[k].i + c[kp].i; 
	c[kp].r = c[k].r-c[kp].r;
	c[kp].i = c[k].i-c[kp].i;
	c[kp].r = (c[k].r * wp[zp].r)-(c[k].i*wp[zp].i);
	c[kp].i = (c[k].r * wp[zp].i)+(c[k].i*wp[zp].r);
	c[k].r = t.r;
	c[k].i = t.i;

      }
      zp = (zp + z) % samples;
    }
    p >>= 1;
    z *= 2;
  }
  a = 2.0 / sqrt(samples);
  printf("a : %df\n",a);
  */
};

/*i need to take a nice long look at this on paper*/






