/* $Id: docking.h,v 1.1.1.1 1998/05/06 19:13:32 matt Exp $
   $Log: docking.h,v $
   Revision 1.1.1.1  1998/05/06 19:13:32  matt
   Imported sources

   Revision 1.1  1998/03/02 14:32:29  matt
   *** empty log message ***


   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   */


#ifndef _DOCKING_H_
#define _DOCKING_H_

#include <stdio.h>
#include <qpixmap.h>
#include <qtimer.h>
#include <qpopmenu.h>

#include <drag.h>

class DockWidget : public QWidget {

  Q_OBJECT

public:
  DockWidget(const char *name=0);
  ~DockWidget();

  /*
     * hack to get static classes up and running even with C++-Compilers/
     * Systems where a constructor of a class element declared static
     * would never get called (Aix, Alpha,...). In the next versions these
     * elements should disappear.
     */
  static void InitStatic() {
    animDock = new QList<QPixmap>;
  }

protected:
  void paintEvent(QPaintEvent *e);

private slots:
  void timeclick();
  void toggle_window_state();
  void mousePressEvent(QMouseEvent *e);

public slots:
  void dock();
  void undock();
  void paintIcon();
  void slotDropEvent( KDNDDropZone * );

public:
  const bool isDocked();

private:
  bool docked;
  int toggleID;

  QPopupMenu *popup_m;
  QTimer     *clocktimer;
  QString    oldtip;

  static QList<QPixmap> *animDock;

};

#endif
